--- Version 1.17 beta by morphone
local MC_Ver="1.17beta";

if MorphClock then
	if tonumber((string.gsub(MC_Ver,"[^0-9.,]",""))) > tonumber((string.gsub(MorphClock.VERSION,"[^0-9.,]",""))) then
		MorphClock={};
	else
		return
	end
end
MorphClock=MorphClock or {};
local MC={};

SLASH_MORPHCLOCK1 = "/morphclock";

SlashCmdList["MORPHCLOCK"]=function(_, text)
	MorphClock.Handler(text)
end

MorphClock.vars=MorphClock.vars or {};

MorphClock.vars.dayspermonth={31,28,31,30,31,30,31,31,30,31,30,31};

MorphClock.vars.UTCshift=0;
MorphClock.vars.daynames={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"};
MorphClock.vars.shortdaynames={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"};
MorphClock.vars.monthnames={"January","February","March","April","May","June","July","August","September","October","November","December"};
MorphClock.vars.shortmonthnames={"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"};
MorphClock.vars.strings={};
MorphClock.vars.strings["CURRENTADJUST"]="Current time adjustment is ";
MorphClock.vars.strings["SETTIMESHIFT"]=" Time adjustment set to %d";

MorphClock.VERSION=MC_Ver;
MorphClock.vars.MAXTRYS=10;
MorphClock.vars.INITIALDELAY=4;
MorphClock.vars.active=true;
MorphClock.vars.loaded=false;
MorphClock.vars.settings={};
MorphClock.vars.settings.timeshift=0;

MorphClock.vars.trys=0;
MorphClockSettings={};

local debug=false;

--@-----------------------------------------------timer frame section--------------------------------------------
function MorphClock:OnTimerUpdate(this,elapsedTime)

	if self.vars.timer_remaining~=nil then
		self.vars.timer_remaining=self.vars.timer_remaining-elapsedTime;
		if self.vars.timer_remaining<=0 then
			self.vars.timer_remaining=0;
			--MC:DebugMsg("Timers up for "..tostring(self.vars.curdelay)..", "..tostring(self.vars.timer_callback));
			this:Hide();
			if type(self.vars.timer_callback)=="function" then
				local callfunc=self.vars.timer_callback;
				self.vars.timer_callback=nil;
				callfunc();

			end;
		end;
	end
end
--@--------------------------------------------------------------------------------------------------------------
function MorphClock:OnTimerLoad(this)

 self.vars.initialized=false;
 self.vars.timerframe=this;
 self.vars.loaded=false;
 self.vars.location=GetLocation();
 if self.vars.location then self.vars.location=string.lower(self.vars.location);end;
 self.vars.language=GetLanguage();
 if self.vars.language then self.vars.language=string.lower(self.vars.language);end;
 MC:Localize();
 SaveVariables("MorphClockSettings");
 this:RegisterEvent("VARIABLES_LOADED");
 this:RegisterEvent("LOADING_END");
end;
--@--------------------------------------------------------------------------------------------------------------
function MorphClock:OnTimerEvent(this, event, arg1, arg2,arg3,arg4)
	if (event=="VARIABLES_LOADED") then
		for i,v in pairs(_G["MorphClockSettings"])do
			if self.vars.settings[i] then
				self.vars.settings[i]=v;
			end;
		end
		_G["MorphClockSettings"]=self.vars.settings;
	elseif (event=="LOADING_END") then
		if self.vars.initialized==false then
			MC:DebugMsg("Init MorphClock");
			ItemMallFrame:Show();
			ItemMallFrame:Hide();
			MC:SetTimer(self.vars.INITIALDELAY,MC.InitReadItemMall);
			MC:StartTimer();
			MorphClock.vars.initialized=true;
		end;
	end
end;
--@---------------------------------------------------------end timer frame section-----------------------------------
function MorphClock.Handler(cmd_)
	local self=MorphClock;
	MC:DebugMsg("MorphClock Handler called with:"..tostring(cmd_));
	if not cmd_ or cmd_=="" then
		MC:Echo(self.vars.strings["CURRENTADJUST"]..tostring(self.vars.settings.timeshift).." min");
	elseif tonumber(cmd_) then
		self.vars.settings.timeshift=math.floor(tonumber(cmd_));
		local msg=string.format(self.vars.strings["SETTIMESHIFT"],self.vars.settings.timeshift);
		MC:Echo(msg);
	end
end

--@-------------------------------private functions----------------------------------------------
function MC:SetTimer(delay,callback)
	local self=MorphClock;
	--MC:DebugMsg("SetTimer called with "..tostring(delay));
	if tonumber(delay)~=nil then
		self.vars.curdelay=delay;
		self.vars.timer_remaining=delay;
		if type(callback)=="function" then
			self.vars.timer_callback=callback;
		end;
	end
end

function MC:StartTimer()
	MorphClockTimerFrame:Show();
end


function MC.InitReadItemMall()
	local self=MorphClock;
	self.vars.trys=self.vars.trys+1;
	self:GetFirstDailyOfferGUID();
	MC.GetTime();
end

function MC.GetTimeCallBack()
	local self=MorphClock;
	self.vars.trys=self.vars.trys+1;
	MC.GetTime();
end



function MC.GetTime()
	local result=0;
	local uresult=0;
	local self=MorphClock;
	if self.vars.active then
		self.vars.trys=self.vars.trys or 0;

		--MC:DebugMsg("Versuch "..self.vars.trys.." um Zeit zu erhalten");
		if self.vars.dailyofferguid and tonumber(self.vars.dailyofferguid)>0 then
			local GUID,name,_,_,_,_,_,_,_,_,_,_,TimeMsg=CIMF_GetItemInfo(0,self.vars.dailyofferguid);

			if GUID~=-1 then
				--MC:DebugMsg("GUID:"..GUID..","..name);

				result,uresult=MC.ParseTimeMsg(TimeMsg);

				if result>0 then
					self.vars.time=result;
					self.vars.utctime=uresult;
					self.vars.utctimetab=MC:CreateTimeTab(uresult);
					self.vars.timetab=MC:CreateTimeTab(result);
					MC:SetRepArray(self.vars.timetab,self.vars.utctimetab);
					if not self.vars.loaded then
						MC:PostMsgClockReady(self.vars.timetab)
					end
					self.vars.loaded=true;
					MC:SetTimer(1,MC.GetTimeCallBack)
					MC:StartTimer()
				else
					MC:SetTimer(0.5*(self.vars.trys+1),MC.InitReadItemMall)
					MC:StartTimer()
				end;
				self.vars.trys=0;
			elseif self.vars.trys<self.vars.MAXTRYS then
				MC:SetTimer(0.5*(self.vars.trys+1),MC.InitReadItemMall)
				MC:StartTimer()
			else
				MC:Error("No valid ItemGUID found..MorphClock deactivated");
				self.vars.active=false;
			end
		elseif self.vars.trys<self.vars.MAXTRYS then
			MC:SetTimer(0.5*(self.vars.trys+1),MC.InitReadItemMall)
			MC:StartTimer()
		else
			MC:Error("No valid dailyofferguid..MorphClock deactivated");
			self.vars.active=false;
		end
	end
	return result;
end
--@--------------------------------------------------------------

 MC.ParseTimeMsg=function (timemsg)
	local self=MorphClock;
	timemsg=MC:StripColor(timemsg);
	local curtime=0;
	local utctime=0;

	local x,y,hit=string.find(timemsg,"\n(.+)");
	if hit then
		local start,ende,endtime=string.find(hit,"(.+)\n");
		local _,_,lefttime=string.find(hit,"\n(.+)");

		--MC:DebugMsg("EndTime: "..tostring(endtime).." LeftTime: "..tostring(lefttime))
		if endtime and lefttime then
			local _,_,year,month,day,hour,min,sec=string.find(endtime,"(%d+)/(%d+)/(%d+)%s+(%d+):(%d+):(%d+)");
			--MC:DebugMsg("Endtime:"..day.."/"..month.."/"..year.." "..hour..":"..min..":"..sec);

			local _,_,days,lhour,lmin,lsec=string.find(lefttime,"(%d+):(%d+):(%d+):(%d+)");
			--MC:DebugMsg("LeftTime:"..days..":"..lhour..":"..lmin..":"..lsec);

			local stime=0;
			if year and month and day and hour and min and sec then
				stime=self:time({year=year,month=month,day=day,hour=hour,min=min,sec=sec});
			end

			local ltime=0;
			if days and lhour and lmin and lsec then
				ltime=86400*(days)+3600*lhour+60*lmin+lsec;
			end;
			if not self.vars.settings.timeshift then
				self.vars.settings.timeshift=0;
			end;
			utctime=stime-ltime+self.vars.settings.timeshift*60;
			curtime=utctime;
			local timetab=MC:CreateTimeTab(curtime);
			if self:IsSummerTime(timetab.day,timetab.month,timetab.year,timetab.hour) then
				utctime=utctime-3600;
			end;
			utctime=utctime-(3600*self.vars.UTCshift);

			--MC:DebugMsg("Curtime:"..tostring(curtime)..","..MC:date("",curtime)..",UTC:"..MC:date("",utctime));

		end
	end
	return curtime ,utctime;
end;

--@--------------------------------------------------------------
function MC:DebugMsg(m_msg)
	if debug==true then
		DEFAULT_CHAT_FRAME:AddMessage(tostring(m_msg),0.9,0.9,0.9);
	end
end;

function MC:Echo(m_msg)
	DEFAULT_CHAT_FRAME:AddMessage(tostring(m_msg),0.9,0.9,0.9);
end;

function MC:Error(m_msg)
	DEFAULT_CHAT_FRAME:AddMessage("ERROR:"..tostring(m_msg),0.9,0.9,0.9);
end;
--@-----------------------------------------------------------
function MC:StripColor(str)
	local mstr;
	if str==nil then return nil;end;
	mstr=string.gsub(str,"|cff([%da-fA-F][%da-fA-F][%da-fA-F][%da-fA-F][%da-fA-F][%da-fA-F])","");
	mstr=string.gsub(mstr,"|r","");
	return mstr;
end
--@---------------------------------------------------------------
function MC:FormatTwoDigits(value)
	local result=value or "00";
	if tonumber(value) and tonumber(value)<10 then
		result="0"..value;
	end;
	return result;
end

--@----------------------------------------------------------------------------
function MC.Replacer(val1,val2)
	local self=MorphClock;
	local result="";
	local prefix="";
	if val1=="!" then prefix="utc";end;
	if type(self.vars.reparray)=="table" and self.vars.reparray[prefix..val2] then
		result=self.vars.reparray[prefix..val2];
	end
	--MC:DebugMsg("Replacer called with ".. tostring( val1).." , "..tostring(val2).." = "..tostring(result).. " prefix:"..tostring(prefix));
	return result;

end
--@----------------------------------------------------------------------------
function MC:SetRepArray(timetab,utctimetab)
	local self=MorphClock;
	--prepare replace array:
		self.vars.reparray={};

		local repa=self.vars.reparray;
		local shortyear=string.sub(timetab.year,3);
		repa.Y=MC:FormatTwoDigits(timetab.year);
		repa.y=MC:FormatTwoDigits(shortyear);
		repa.m=MC:FormatTwoDigits(timetab.month);
		repa.d=MC:FormatTwoDigits(timetab.day);
		repa.H=MC:FormatTwoDigits(timetab.hour);
				local suffix="am";
		if tonumber(timetab.hour) and tonumber(timetab.hour) >12 then suffix="pm";end;
		repa.p=suffix;
		repa.w=timetab.wday-1;
		local ihour=tonumber(timetab.hour) or 0;
		if ihour>12 then ihour=ihour-12;end;
		repa.I=MC:FormatTwoDigits(ihour);
		repa.M=MC:FormatTwoDigits(timetab.min);
		repa.S=MC:FormatTwoDigits(timetab.sec);
		repa.c=repa.m.."/"..repa.d.."/"..repa.y.." "..repa.H..":"..repa.M..":"..repa.S;
		repa.x=repa.m.."/"..repa.d.."/"..repa.y;
		repa.X=repa.H..":"..repa.M..":"..repa.S;
		repa.a=self.vars.shortdaynames[timetab.wday];
		repa.A=self.vars.daynames[timetab.wday];
		repa.b=self.vars.shortmonthnames[timetab.month];
		repa.B=self.vars.monthnames[timetab.month];
		--utc:
		if type(utctimetab)=="table" then
			shortyear=string.sub(utctimetab.year,3);
			repa.utcY=MC:FormatTwoDigits(utctimetab.year);
			repa.utcy=MC:FormatTwoDigits(shortyear);
			repa.utcm=MC:FormatTwoDigits(utctimetab.month);
			repa.utcd=MC:FormatTwoDigits(utctimetab.day);
			repa.utcH=MC:FormatTwoDigits(utctimetab.hour);
			suffix="am";
			if tonumber(utctimetab.hour)  and tonumber(utctimetab.hour) >12 then suffix="pm";end;
			repa.utcp=suffix;
			repa.utcw=utctimetab.wday-1;
			ihour=tonumber(utctimetab.hour) or 0;
			if ihour>12 then ihour=ihour-12;end;
			repa.utcI=MC:FormatTwoDigits(ihour);
			repa.utcM=MC:FormatTwoDigits(utctimetab.min);
			repa.utcS=MC:FormatTwoDigits(utctimetab.sec);
			repa.utcc=repa.utcm.."/"..repa.utcd.."/"..repa.utcy.." "..repa.utcH..":"..repa.utcM..":"..repa.utcS;
			repa.utcx=repa.utcm.."/"..repa.utcd.."/"..repa.utcy;
			repa.utcX=repa.utcH..":"..repa.utcM..":"..repa.utcS;
			repa.utca=self.vars.shortdaynames[utctimetab.wday];
			repa.utcA=self.vars.daynames[utctimetab.wday];
			repa.utcb=self.vars.shortmonthnames[utctimetab.month];
			repa.utcB=self.vars.monthnames[utctimetab.month];
		end
end
--@----------------------------------------------------------------------------
function MC:FormatDate(format,time,timetab)
	local result="";
	local self=MorphClock;
	if format==nil or format=="" then format="%c";end;
	--MC:DebugMsg("FormatDate called with:"..tostring(format).." , "..tostring(time).." , "..tostring(timetab));
	if type(format)=="string" and tonumber(time) then
		if type(timetab)~="table" then timetab=MC:CreateTimeTab(time);end;
		local utctime=time-(3600*self.vars.UTCshift);
		if timetab.isdst==true then
			utctime=utctime-3600
		end
		local utctimetab=MC:CreateTimeTab(utctime);
		MC:SetRepArray(timetab,utctimetab);
		result=string.gsub(format,"(!?)%%([ABHIMSXYabcdmpwxy])",MC.Replacer)
	end
	return result;
end
--@---------------------------------------------------------------------------------
function MC:CreateTimeTab(time_)
	local self=MorphClock;
	local result={};
	local year,month,day,hour,min,sec;
	year=1970;
	month=1;
	day=1;
	hour=0;
	min=0;
	sec=0;
	local mtime;
	if tonumber(time_) then
		mtime=time_;

		local days=math.floor(time_/86400);
		if days and tonumber(days)>0 then
			mtime=math.mod(mtime,days*86400);

			if days>365 then
				for i=1,61 do
					if (self:GetDaysSinceBegin((year+i))> days) then
						year=year+i-1;
						break;
					end;
				end

			end
			days=days-self:GetDaysSinceBegin(year)+1;
			month=1;

			if tonumber(days)>31 then
				for x=2,13 do
					if (self:GetDaythisYear(1,x,year)> days) then
						month=x-1;
						break;
					end;
				end
			days=days-self:GetDaythisYear(1,month,year)+1;
			end
			day=days;


		end;
		hour=math.floor(mtime/3600);
		if hour>0 then
			mtime=math.mod(mtime,hour*3600);
		end;
		min=math.floor(mtime/60);
		if min>0 then
			mtime=math.mod(mtime,min*60);
		end;
		sec=mtime;
	end
	local wday=self:GetWeekday(day,month,year);
	local yday_=self:GetDaythisYear(day,month,year);
	local isdst_=self:IsSummerTime(day,month,year,hour)
	result={min=min,hour=hour,wday=wday,year=year,yday=yday_,month=month,sec=sec,day=day,isdst=isdst_};

	return result;
end
--@---------------------------------------------------------------------------------
function MC:date(format,time_)
	--self:DebugMsg("MC:Date:"..tostring(format)..","..tostring(time_));
	local self=MorphClock;
	local result="";
	local timewas=time_;
	local timetab;
	local mtime;
	local utctimetab;
	if not time_ then
		time_=self.vars.time;
		timetab=self.vars.timetab
		utctimetab=self.vars.utctimetab;
	else
		timetab=MC:CreateTimeTab(time_);
		local utctime=time_-(3600*self.vars.UTCshift);
		if timetab.isdst==true then
			utctime=utctime-3600
		end
		utctimetab=MC:CreateTimeTab(utctime);
	end




	if format then

			if format=="*t" then
				result=timetab;
			elseif format=="!*t" then
				result=utctimetab;
			else
				local myttab=MC:CopyTable(timetab);
				result=MC:FormatDate(format,time_,myttab);
				if (string.find(format,"*TEST*")) then
					MC:DebugMsg(result);
				end;
				if timewas then
					MC:SetRepArray(timetab,utctimetab);
				end
			end
	else
			result=MC:FormatDate("",time_,timetab);
	end


	return result;
end;
--@--------------------------------------------------------------------------------
function MC:Localize()
	local self=MorphClock;
	if self.vars.location and self.vars.language then
		if self.vars.location=="de" or self.vars.location=="eneu" then
			self.vars.UTCshift=1;
		end;
		if self.vars.language=="de" then
			MorphClock.vars.daynames={"Sonntag","Montag","Dienstag","Mittwoch","Donnerstag","Freitag","Samstag"};
			MorphClock.vars.shortdaynames={"So","Mo","Di","Mi","Do","Fr","Sa"};
			MorphClock.vars.monthnames={"Januar","Februar","März","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember"};
			MorphClock.vars.shortmonthnames={"Jan","Feb","März","Apr","Mai","Jun","Jul","Aug","Sep","Okt","Nov","Dez"};
			MorphClock.vars.strings["CURRENTADJUST"]="Der momentane Zeitkorrekturfaktor ist ";
			MorphClock.vars.strings["SETTIMESHIFT"]=" Zeitkorrekturfaktor wurde auf %d gesetzt";
		end
	end
end
--@---------------------------------------------------------------------------------
function MC:mygetglobal(str)
	local addr;
	if type(str)=="string" then
		local _,_,tab=string.find(str,"(.+)%.");
		local _,_,mfunc=string.find(str,"%.(.+)");
		if not tab and not mfunc then
			addr=_G[str];
		elseif type(_G[tab])=="table" and (_G[tab][mfunc]~=nil) then
			addr=_G[tab][mfunc]
		end;
	end
	return addr;
end
--@----------------------------------------------------------------------------------
function MC:PostMsgClockReady(time)
	local self=MorphClock;
	if type(self.vars.registeredfuncs)=="table" then
		local funcpt;
		for _,v in ipairs(self.vars.registeredfuncs) do
			funcpt=MC:mygetglobal(v);
			if type(funcpt)=="function" then
				funcpt(time);
			end;
		end
	end
end

 ------------------------------------------------------
 function MC:CopyTable(source)--attention dont use this for tables which contain references to themself or parenttables in which these tables are included
	local target={};
	if type(source)=="table"  then
		for var,wert in pairs(source) do
				if (type(wert)=="table") then
				 target[var]=self:CopyTable(wert);
				else
				 target[var]=wert;
				end;
		end;
	end
	return target
 end
--@----------------------------------end private functions--------------------------
--@-------------------------Public functions:----------------------------------------
--- Dont use it to often because it requires a change of categories in the itemshop
---@return The GUID of the first item of the daily offer category or 0
function MorphClock:GetFirstDailyOfferGUID()
	--MC:DebugMsg("GetFirstDailyOfferGUID called");
	local oldselect=ItemMallFrame.selected;

	CIMF_SelectFilterIndex(1245440,-1);-- select dailyoffers
	self.vars.dailyofferguid=ItemMallList1:GetID();
	if oldselect then
		CIMF_SelectFilterIndex(oldselect,-1);
	end;
	if self.vars.dailyofferguid~=0 then
		MC:DebugMsg("GetFirstDailyOfferGUID:"..tostring(self.vars.dailyofferguid));
	end;

	ItemMallFrame.selected=oldselect;
end
---------------------------------------------------------------------------------------
--- similar to the os.time function returns the seconds since the 1.1.1970 00:00:00 for a given time or for the current time.
--@param timetab table with timefields or nil for the current time<br>
-- Table may contain the following fields:
-- <ul><li>sec =0-59</li>
--<li>min = 0-59</li>
--<li>hour= 0-23</li>
--<li>day = 1-31</li>
--<li>month = 1-12</li>
--<li>year = 1970-</li>
--</ul>
--@return the seconds till 1.1.1970 00:00:00 for the given time or the current time
-- 0 for timetab is no table or invalid field in timetab
--<br><hr>
function MorphClock:time(timetab)
	local result=0;
	if type(timetab)=="table" then
		local _,_,year,month,day,hour,min,sec;
		sec=tonumber(timetab.sec) or 0;
		min=tonumber(timetab.min) or 0;
		hour=tonumber(timetab.hour) or 0;
		day=tonumber(timetab.day) or 1 ;
		month=tonumber(timetab.month) or 1;
		year=tonumber(timetab.year) or 1970;
		yday=tonumber(self:GetDaythisYear(day,month,year)) or 1;

		local tmpdays
		if yday<1 then
			tmpdays=0;
		else
			tmpdays=yday-1;
		end

		local totaldays=self:GetDaysSinceBegin(year)+tmpdays;

		if year<1970 then year=1970;end;
		result=86400*(totaldays)+3600*hour+60*min+sec
	elseif self.vars.time then
		result=self.vars.time;
	end
	return result
end
----------------------------------------------------------------
--similar to the os.date function returns a formated string or a table for a given time or the current time
--@param format either a formatstring or *t for a table of time<br>
-- Known formattags are:
--<table border=1><tr><td>tag</td><td>description</td></tr>
--<tr><td>%a </td><td>	abbreviated weekday name (e.g., Wed)</td></tr>
--<tr><td>%A </td><td>	full weekday name (e.g., Wednesday)</td></tr>
--<tr><td>%b </td><td>	abbreviated month name (e.g., Sep)</td></tr>
--<tr><td>%B </td><td>	full month name (e.g., September)</td></tr>
--<tr><td>%c </td><td>	date and time (e.g., 09/16/98 23:48:10)</td></tr>
--<tr><td>%d </td><td>	day of the month (16) [01-31]</td></tr>
--<tr><td>%H </td><td>	hour, using a 24-hour clock (23) [00-23]</td></tr>
--<tr><td>%I </td><td>	hour, using a 12-hour clock (11) [01-12]</td></tr>
--<tr><td>%M </td><td>	minute (48) [00-59]</td></tr>
--<tr><td>%m </td><td>	month (09) [01-12]</td></tr>
--<tr><td>%p </td><td>	either "am" or "pm" (pm)</td></tr>
--<tr><td>%S </td><td>	second (10) [00-61]</td></tr>
--<tr><td>%w </td><td>	weekday (3) [0-6 = Sunday-Saturday]</td></tr>
--<tr><td>%x </td><td>	date (e.g., 09/16/98)</td></tr>
--<tr><td>%X </td><td>	time (e.g., 23:48:10)</td></tr>
--<tr><td>%Y </td><td>	full year (1998)</td></tr>
--<tr><td>%y </td><td>	two-digit year (98) [00-99]</td></tr>
--<tr><td> !"oneoftheabove"</td><td> if u want to get the utctime e.g !%H </td></tr></table>
--@param time  number of seconds since 1.1.1970 or nil if u want to get the current time
--@return The formated string "format" ,or a table for "format"= "*t" or "!*t",<br> or date and time (e.g., 09/16/98 23:48:10) if no format is given<br>  else "" if no time is available or an error occured,<br>
-- The returned table has the values:<br><ul>
--<li>hour =0-23</li>
--<li>min =Minute 0-59</li>
--<li>sec =seconds</li>
--<li>wday =1(Sunday)-7(Saturday)</li>
--<li>day =1-31</li>
--<li>month =1-12</li>
--<li>year =1970-</li>
--<li>yday =day of the year</li>
--<li>isdst =true if it is daylight saving time (aka summertime) or false</li></ul><hr>

function MorphClock:date(format,time)
	local result="";
	local year,month,day,hour,min,sec;
	year=1970;
	month=1;
	day=1;
	hour=0;
	min=0;
	sec=0;
	if not format then format="%c";end;
	if not time and type(self.vars.reparray)=="table" then
		if format=="*t" then
			result=MC:date("*t");
		elseif format=="!*t" then
			result=MC:date("!*t");
		else
			result=string.gsub(format,"(!?)%%([ABHIMSXYabcdmpwxy])",MC.Replacer)
		end;
	elseif tonumber(time) then
		result=MC:date(format,time);
	end;
	return result;
end;
------------------------------------------------------------------
-- Is the given year a leapyear or not?
--@param year 1970-
--@return true for year is a leapyear else false<br><hr>
--thx to conzales for the improvement
function MorphClock:IsLeapYear(year)
	result=false;
	if tonumber(year) then
		if (tonumber(year)<1970 ) then
			MC:Error("IsLeapYear:Year must be inside range of 1970-, but is :"..tostring(year));
		else
			result=((math.mod(year,4) == 0)  and  (math.mod(year,100) ~= 0)) or (math.mod(year,400) == 0);
		end
	end
	return result;
end
---------------------------------------------------------------------
-- returns the yearday for a given date
--@param day 1-31
--@param month 1-12
--@param year 1970-
--@return day of the year for the given date or 0 for errors or unknown dates.e.g. 2.Januar.2010 would be the 2 day of the year<br><hr>
function MorphClock:GetDaythisYear(day,month,year)
	local result=0;
	if tonumber(day) and tonumber(month) and tonumber(year) then
		month=tonumber(month);
		day=tonumber(day);
		if month>1 then
			for i=1,month-1 do
				result=result+self.vars.dayspermonth[i]
				if i==2 and self:IsLeapYear(year) then
					result=result+1;
				end;
			end
		end
		result=result+day;
	end
	return result;
end
------------------------------------------------------------------------------
-- returns the days fom 1.1.1970 till 1.1 of the given year
--@param year 1970-
--@return days from 1.1.1970 till 1.1.year<br><hr>
function MorphClock:GetDaysSinceBegin(year)
	local result=0;
	if tonumber(year) and tonumber(year)>=1970 then
		year=tonumber(year);
		if year>1970 then
			for i=1970,year-1 do
				result=result+365;
				if self:IsLeapYear(i) then
					result=result+1;
				end;

			end
		end
	end
	return result;
end
-------------------------------------------------------------------------------
-- Returns Weekday for a given date
--@param day 1-31
--@param month 1-12
--@param year 1970-
--@return weekday from Sunday 1 to Saturday 7 <br><hr>
function MorphClock:GetWeekday(day,month,year)
	local result=-1;
	local days=MorphClock:GetDaythisYear(day,month,year);
	days=days+ MorphClock:GetDaysSinceBegin(year);
	--01.01.1970 was a Thursday
	result=math.mod(days-1,7);
	if result<=2 then
		result=result+5;
	else
		result=result-2;
	end;
	return result;
end
----------------------------------------------------------------------------------
-- Determines if given time is within the summertime or not.
-- Works with the rules for summertime in germany.
-- last sunday in march and last sunday in october
--@param day the day of the date 1-31
--@param month the month of the date 1-12
--@param year the year of the date 1970-
--@param hour the hour of the time 0-23
--@return true if the given time is within the summertime  else false<br><hr>
function MorphClock:IsSummerTime(day,month,year,hour)
	local result=false;
	if (tonumber(month) and tonumber(day) and tonumber(year)) then
		month=tonumber(month);
		year=tonumber(year);
		day=tonumber(day);
		if month>3 and month<10 then
			result=true;
		elseif month==3 then
			local wday=self:GetWeekday(31,3,year);
			local keyday=31-wday+1;
			if day>keyday then
				result=true;
			elseif day==keyday and hour>=2 then
				result=true;
			end;
		elseif month==10 then
			local wday=self:GetWeekday(31,10,year);
			local keyday=31-wday+1;
			--MC:DebugMsg("IsSummerTime:"..wday..","..keyday..","..day);
			if day<keyday then --there will be an error of one hour in the night of the timeshift
				result=true;
			elseif day==keyday and hour<=2 then
				result=true;
			end;
		end
	else
		MC:Error("IsSummerTime:Invalid params");
	end
	return result;
end

------------------------------------------------------------------------------------
-- Is there a valid time available?
--@return true if there is a valid time else false<br><hr>
function MorphClock:IsValid()
 local result=false;
 if self.vars.loaded==true and self.vars.active==true and self.vars.time>0 then
	result=true;
 end
 return result;
end;


--- Registers functions for callback if the clock is ready and represents a valid value
--@param func either a global function witch accepts a timetab as first parameter or a function within a global table e.g. MorphClock.ClockReadyCallback
--<br> important is that u dont pass the variable itself but the name of it as string e.g. "MorphClock.ClockReadyCallBack"
--@see MorphClock:date("*t") for details on the returned table
--
--<br><hr>

function MorphClock:RegisterClockReady(func)
	local funcadr=MC:mygetglobal(func);
	if type(funcadr)=="function" then
		self.vars.registeredfuncs=self.vars.registeredfuncs or {};
		local found =false;
		for i,v in ipairs(self.vars.registeredfuncs) do

		 if v==func then
			found=true;
			break;
		 end
		end
		if not (found==true) then
			table.insert(self.vars.registeredfuncs,func);
			MC:DebugMsg("Registered function:"..tostring(func));
		end;
	end
end

--- Removes functions from the internal callback list
--@param func either a global function witch accepts a timetab as first parameter or a function within a global table e.g. MorphClock.ClockReadyCallback
--<br> important is that u dont pass the variable itself but the name of it as string e.g. "MorphClock.ClockReadyCallBack"
--<br><hr>

function MorphClock:UnregisterClockReady(func)

	if type(func)=="string" then
		self.vars.registeredfuncs=self.vars.registeredfuncs or {};
		for i,v in ipairs(self.vars.registeredfuncs) do
			if v==func then
				table.remove(self.vars.registeredfuncs,i)
			end;
		end

	end
end
--- Calculates the difference between two times in seconds
--@param t2 either an amount of seconds or a timetab
--@param t1 either an amount of seconds or a  timetab
--@see MorphClock:time
-- for details on the timetab fields
--@return the difference between the two times (t2-t1) in seconds or -1 if the calculation failed<br><hr>
function MorphClock:difftime(t2,t1)
	local result=-1;
	if type(t2)=="table" then
		t2=self:time(t2);
	end;
	if type(t1)=="table" then
		t1=self:time(t1);
	end;
	if tonumber(t2) and tonumber(t1) then
		result=math.floor(t2-t1+0.5);
	end
	return result
end
--- Converts a utc timestamp to locale time
--@param time the UTC timestamp
--@return the localized timestamp
function MorphClock:UTCToLocale(time)
	local result=time;
	if tonumber(time) then
		result=time+MorphClock.vars.UTCshift*3600;
		local timetab=MC:date("*t",time);
		if timetab.isdst==true then
			result=result+3600;
		end;
	end
	return result;
end
