--[=[ RoMBaNodes
	by Caandera
	released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
]=]

RoMBaFullOverdura = false;

if (type(RoMBaNode) ~= "table") then 
	RoMBaNode = {};
end;
RoMBaNode["RoMBaCharInfo"] = {
	GetIcon = function()
		local class1, class2 = UnitClassToken("player");
		if class1 ~= nil and class2 ~= nil then
			local picString = "interface/widgeticons/classicon_"..string.lower(class1);
			if class2 ~= "" then
				picString = picString.."_"..string.lower(class2);
			end;
			return(picString..".tga");
		end
	end,
	GetText = function()
		if UnitName("player") ~= nil then
			local xOut = 16 + (9 * string.len(UnitName("player")));
			if RoMBaNode["RoMBaCharInfo"].x ~= xOut then
				RoMBaNode["RoMBaCharInfo"].x = xOut;
				RoMBaFrame_Update();
			end;
		end;
		return(setColoredText("WHITE", UnitName("player")));
	end,
	x = 140,
	OnLoad = function(this)		
	end,
	OnEvent = function(event)		
	end,
	OnUpdate = function()
	end,
	OnClick = function()
		ToggleCharacter("EquipmentFrame");
	end,
	OnEnter = function(this)
		if UnitName("player") ~= nil then
			local mainClass, subClass = UnitClass("player");
			RoMBaTooltipAnchor(this:GetName());
			RoMBaTooltip:SetText(UnitName("player"));
			RoMBaTooltip:AddLine(" ");
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("CHARACTER_FRAME_TITLE")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("SOCIAL_DETAIL_CLASS1_COLON")), mainClass.." ("..RoMBaLevel(1)..")");
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("SOCIAL_DETAIL_CLASS2_COLON")), subClass.." ("..RoMBaLevel(2)..")");
			RoMBaTooltip:AddLine(" ");
			RoMBaTooltip:AddLine(setColoredText("GREEN", rombaLocale["Tooltip"]["ATTRIBUTE"]));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_STR")..":"), RoMBaGetCharAbi("STR"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_AGI")..":"), RoMBaGetCharAbi("AGI"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_STA")..":"), RoMBaGetCharAbi("STA"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_INT")..":"), RoMBaGetCharAbi("INT"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MND")..":"), RoMBaGetCharAbi("MND"));
			RoMBaTooltip:AddLine(" ");
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("MESSAGE_FIGHT")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_DPS")..":"), RoMBaGetCharAbi("DPS"));
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("MELEE")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_DAMAGE")..":"), RoMBaGetCharAbi("MELEE_MAIN_DAMAGE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_ATTACK")..":"), RoMBaGetCharAbi("MELEE_ATTACK"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_CRITICAL")..":"), RoMBaGetCharAbi("MELEE_CRITICAL"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_HIT")..":"), RoMBaGetCharAbi("PHYSICAL_HIT"));
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("RANGE")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_DAMAGE")..":"), RoMBaGetCharAbi("RANGE_DAMAGE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_ATTACK")..":"), RoMBaGetCharAbi("RANGE_ATTACK"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_CRITICAL")..":"), RoMBaGetCharAbi("RANGE_CRITICAL"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_HIT")..":"), RoMBaGetCharAbi("PHYSICAL_HIT"));
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("MAGIC")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_DAMAGE")..":"), RoMBaGetCharAbi("MAGIC_DAMAGE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_ATTACK")..":"), RoMBaGetCharAbi("MAGIC_ATTACK"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_CRITICAL")..":"), RoMBaGetCharAbi("MAGIC_CRITICAL"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_HEAL_POINT")..":"), RoMBaGetCharAbi("MAGIC_HEAL"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_HIT")..":"), RoMBaGetCharAbi("MAGIC_HIT"));
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("PHYSICAL_DEFENCE")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_DEFENCE")..":"), RoMBaGetCharAbi("PHYSICAL_DEFENCE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_PARRY")..":"), RoMBaGetCharAbi("PHYSICAL_PARRY"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_DODGE")..":"), RoMBaGetCharAbi("PHYSICAL_DODGE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_PHYSICAL_RESIST_CRITICAL")..":"), RoMBaGetCharAbi("PHYSICAL_RESIST_CRITICAL"));
			RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("MAGIC_DEFENCE")));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_DEFENCE")..":"), RoMBaGetCharAbi("MAGIC_DEFENCE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_DODGE")..":"), RoMBaGetCharAbi("MAGIC_DODGE"));
			RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_MAGIC_RESIST_CRITICAL")..":"), RoMBaGetCharAbi("MAGIC_RESIST_CRITICAL"));
		end;
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};

local RoMBaXP_display = 1;

RoMBaNode["RoMBaExperience"] = {
	GetIcon = function()
		return("Interface/AddOns/RoMBa/Textures/xp.tga");
	end,
	GetText = function()
        local percentXp = math.ceil(GetPlayerExp(player)/GetPlayerMaxExp(player)*100);
        if RoMBaXP_display == 1 then
		    return(percentXp.."%");
        else
            local neededXp = GetPlayerMaxExp("player")-GetPlayerExp("player");
            return(seperateNumbers(neededXp).." ("..percentXp.."%)");
        end;
	end,
	x = 48,
	OnLoad = function(this)		
		this:RegisterEvent("PLAYER_EXP_CHANGED");
		this:RegisterEvent("EXCHANGECLASS_SUCCESS");
		this:RegisterForClicks("LeftButton", "RightButton");
	end,
	OnEvent = function(event)
		if event == "PLAYER_EXP_CHANGED" then
			xpMakeUpdate();
		elseif event == "EXCHANGECLASS_SUCCESS" then
			xpSet(); 
		end;		
	end,
	OnUpdate = function()
		if (type(RoMBaVariables) == "table") then
			local itemChanged = false;
			if RoMBaXP_display == 1 and RoMBaVariables["XpDisplay"] then
				RoMBaNode["RoMBaExperience"].x = 115;
				RoMBaXP_display = 2;
				itemChanged = true;
			elseif RoMBaXP_display == 2 and not RoMBaVariables["XpDisplay"] then
				RoMBaNode["RoMBaExperience"].x = 48;
				RoMBaXP_display = 1;
				itemChanged = true;
			end;
			if itemChanged then
				RoMBaFrame_Update();
			end;
		end;
	end,
	OnClick = function(key)
        if key == "LBUTTON" then
			ToggleUIFrame(UI_SkillBook);
		elseif key == "RBUTTON" then
			if RoMBaXP_display == 1 then
				RoMBaNode["RoMBaExperience"].x = 115;
				RoMBaXP_display = 2;
			else
				RoMBaNode["RoMBaExperience"].x = 48;
				RoMBaXP_display = 1;				
			end;
			if (type(RoMBaVariables) == "table") then
				if RoMBaXP_display == 1 then
					RoMBaVariables["XpDisplay"] = nil;
				else
					RoMBaVariables["XpDisplay"] = true;
				end;
			end;
			RoMBaTooltip:Hide();
			RoMBaFrame_Update();
		end;
	end,
	OnEnter = function(this)
		local ExpDebt, TpDebt = GetPlayerExpDebt();
        local EPexp, EPtp = GetPlayerExtraPoint();
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText("XP");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("QUESTBOOK_QUESTREWARD_EXP")));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("C_LEVEL")..":"), UnitLevel("player"));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["ACTUALXP"]..":"), seperateNumbers(GetPlayerExp("player")).." ("..string.format("%.2f", (GetPlayerExp("player")/GetPlayerMaxExp("player"))*100).."%)");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["NEEDEDXP"]..":"), seperateNumbers(GetPlayerMaxExp("player")-GetPlayerExp("player")).." ("..string.format("%.2f", ((GetPlayerMaxExp("player")-GetPlayerExp("player"))/GetPlayerMaxExp("player"))*100).."%)");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["SUMXP"]..":"), seperateNumbers(GetPlayerMaxExp("player")));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["XPPERHOUR"]..":"), seperateNumbers(getXpPerHour()));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["SESSIONXP"]..":"), seperateNumbers(getSessionXp()));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(setColoredText("GREEN", rombaLocale["Tooltip"]["HOUSEBONUS"]));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["BONUSXP"]), seperateNumbers(EPexp));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["BONUSTP"]), seperateNumbers(EPtp));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(setColoredText("GREEN", rombaLocale["Tooltip"]["DEBT"]));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("DEBT_EXP")), seperateNumbers(ExpDebt));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("DEBT_TP")), seperateNumbers(TpDebt));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(setColoredText("GREEN", getglobal("SKILL_BOOK")));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["TPPERHOUR"]..":"), seperateNumbers(getTpPerHour()));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["SESSIONTP"]..":"), seperateNumbers(getSessionTp()));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["DISTRIBUTETP"]..":"), seperateNumbers(GetTpExp()));
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};

local RoMBaBagId = 1;

RoMBaNode["RoMBaBag"] = {
	GetIcon = function()
		return("Interface/AddOns/RoMBa/Textures/bag.tga");
	end,
	GetText = function()
		local usedSlots, totalSlots = GetBagCount();
		return(getColorFormated(math.ceil((usedSlots/totalSlots)*100), 95, 90, 70, usedSlots.."/"..totalSlots));
	end,
	x = 64,
	OnLoad = function(this)		
		this:RegisterForClicks("LeftButton", "RightButton");
	end,
	OnEvent = function(event)		
	end,
	OnUpdate = function()
	end,
	OnClick = function(key)
		if key == "LBUTTON" then
			ToggleBackpack();
		elseif key == "RBUTTON" and BagFrame:IsVisible() then
			RoMBaBagId = RoMBaBagId + 1;
			local usedSlots, totalSlots = GetBagCount();
			local maxId = totalSlots / BAG_MAX_ITEMS;
			if (RoMBaBagId > maxId) then
				RoMBaBagId = 1;
			end;
			PanelTemplates_SetTab(BagFrame, RoMBaBagId);
			BagFrame_Update();
		end;
	end,
	OnEnter = function(this)
		local usedSlots, totalSlots = GetBagCount();
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText(getglobal("BACKPACK"));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["USED"]..":"), math.ceil((usedSlots/totalSlots)*100).." %");
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};

local moneyIn = 0;
local moneyOut = 0;
local moneyBil = 0;
local actualMoney = GetPlayerMoney("copper");

RoMBaNode["RoMBaMoney"] = {
	GetIcon = function()
		return("Interface/AddOns/RoMBa/Textures/gold.tga");
	end,
	GetText = function()
		local xOut = 16 + (9 * string.len(GetPlayerMoney("copper")));
		if RoMBaNode["RoMBaMoney"].x ~= xOut then
			RoMBaNode["RoMBaMoney"].x = xOut;
			RoMBaFrame_Update();
		end;
		return(setColoredText("WHITE", MoneyNormalization(GetPlayerMoney("copper"))));
	end,
	x = 75,
	OnLoad = function(this)		
		this:RegisterEvent("PLAYER_MONEY");
		this:RegisterEvent("PLAYER_TRADE_MONEY");
	end,
	OnEvent = function(event)
		if event == "PLAYER_MONEY" or event == "PLAYER_TRADE_MONEY" then
			moneyChanged();
		end;
	end,
	OnUpdate = function()
	end,
	OnClick = function()
		doFrameCmd(ItemMallFrame);
	end,
	OnEnter = function(this)
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText(getglobal("TOTAL_MONEY"));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("MONEY_GOLD")..":"), MoneyNormalization(GetPlayerMoney("copper")));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("MONEY_RUBY")..":"), GetPlayerMoney("bonus"));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD",rombaLocale["Tooltip"]["PHIRIUS"]..":"), GetPlayerMoney("billdin"));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", getglobal("MONEY_RUNE")..":"), GetPlayerMoney("account"));
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(setColoredText("GREEN", rombaLocale["Tooltip"]["CASHFLOW"]));
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["CASHIN"]), moneyIn);
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["CASHOUT"]), moneyOut);
		RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["CASHOVERALL"]), getColorFormated(moneyBil*-1,0,0,0,moneyBil));
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};
function moneyChanged()
	if actualMoney < GetPlayerMoney("copper") then
		--Einnahmen
		local diff = (GetPlayerMoney("copper") - actualMoney);
		moneyIn = moneyIn + diff;
		moneyBil = moneyBil + diff;
	elseif actualMoney > GetPlayerMoney("copper") then
		--Ausgaben
		local diff = (actualMoney - GetPlayerMoney("copper"));
		moneyOut = moneyOut + diff;
		moneyBil = moneyBil - diff;
	end;
	actualMoney = GetPlayerMoney("copper");
end;

local damageVisible = false;

RoMBaNode["RoMBaDurability"] = {
	GetIcon = function()
		if RoMBaFullOverdura then
			return("Interface/AddOns/RoMBa/Textures/fulldurability.tga");
		else
			return("Interface/AddOns/RoMBa/Textures/durability.tga");
		end;
	end,
	GetText = function()
		local itemCount = 0;
		local durabilitySum = 0;
		local durabilityMin = 100;
		local itemPercent = 0;
		local durabilityAvg = 0;
		local countOverdura = 0;
		for item = 0, 16 do
			local current, maximum, itemName, cd, md = GetInventoryItemDurable("player", item);
			if maximum > 5 and item ~= 9 and not GetInventoryItemInvalid("player", item) then
				itemCount = itemCount + 1;
				itemPercent = math.ceil(current/maximum*100);
				durabilitySum = durabilitySum + itemPercent;
				if itemPercent < durabilityMin then
					durabilityMin = itemPercent;
				end;
				if current > 100 then
					countOverdura = countOverdura + 1;
				end;
			end;
		end;
		if itemCount > 0 then
			durabilityAvg = math.ceil(durabilitySum/itemCount);
		end;
		if countOverdura == itemCount then
			RoMBaFullOverdura = true;
		else
			RoMBaFullOverdura = false;
		end;
		return(getColorFormated((durabilityMin*-1), -20, -40, -60, durabilityMin.." ("..durabilityAvg..")").."%");
	end,
	x = 85,
	OnLoad = function(this)		
		this:RegisterForClicks("LeftButton", "RightButton");
	end,
	OnEvent = function(event)
	end,
	OnUpdate = function()		
		if (type(RoMBaVariables) == "table") then
			if RoMBaVariables["DmgOverride"] and not damageVisible and EquipDameFrame:IsVisible() then
				EquipDameFrame:Hide();
			end;
		end;
	end,
	OnClick = function(key)
		if key == "LBUTTON" then
			doFrameCmd(EquipDameFrame);
			damageVisible = EquipDameFrame:IsVisible();		
		elseif key == "RBUTTON" then
			SwapEquipmentItem();
		end;
	end,
	OnEnter = function(this)
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText(rombaLocale["Tooltip"]["DURABILITY"]);
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");		
		for item = 0, 16 do
			local current, maximum, itemName, cd, md = GetInventoryItemDurable("player", item);
			if maximum > 0 and item ~= 9 then
				local txtColor = "GOLD";
				if GetInventoryItemInvalid("player", item) then
					txtColor = "RED";
				end;
				local itemPercent = math.ceil(current/maximum*100);
				local duraColor = "YELLOW";
				if current > 100 then
					duraColor = "GREEN";
				end;
				RoMBaTooltip:AddDoubleLine(setColoredText(txtColor, itemName..":"), setColoredText(duraColor, current).."/"..maximum.." ("..itemPercent..")%");
			end;
		end;
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};

RoMBaNode["RoMBaAmmo"] = {
	GetIcon = function()
		return(GetInventoryItemTexture("player",9));
	end,
	GetText = function()
		local ammo = GetInventoryItemCount("player",9);
		local textout = " ";
		local xOut = 0;
		if ammo ~= nil then
			textout = getColorFormated((ammo*-1), -50, -100, -200, ammo);
			xOut = 48;
		end;
		if RoMBaNode["RoMBaAmmo"].x ~= xOut then
			RoMBaNode["RoMBaAmmo"].x = xOut;
			RoMBaFrame_Update();
		end;
		return(textout);
	end,
	x = 48,
	OnLoad = function(this)		
	end,
	OnEvent = function(event)
	end,
	OnUpdate = function()
	end,
	OnClick = function()
	end,
	OnEnter = function(this)
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText(rombaLocale["Tooltip"]["AMMO"]);
		RoMBaTooltip:AddLine(" ");
		RoMBaTooltip:AddLine(" ");		
		local current, maximum, itemName, cd, md = GetInventoryItemDurable("player", 9);
		RoMBaTooltip:AddLine(setColoredText("GOLD",itemName));
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};

RoMBaNode["RoMBaPing"] = {
	GetIcon = function()
		return("Interface/AddOns/RoMBa/Textures/ping.tga");
	end,
	GetText = function()
		return(getColorFormated(GetPing(),750,500,300,GetPing().."ms").." / "..getColorFormated(math.ceil(GetFramerate())*-1,-8,-15,-24,math.ceil(GetFramerate()).." Fps"));
	end,
	x = 128,
	OnLoad = function(this)		
	end,
	OnEvent = function(event)
	end,
	OnUpdate = function()
	end,
	OnClick = function(key)
		if (IsShiftKeyDown()) then
			ReloadUI();
		end;
	end,
	OnEnter = function(this)
	end,
	OnLeave = function()
	end
};

RoMBaNode["RoMBaDaily"] = {
	GetIcon = function()
		return("Interface/AddOns/RoMBa/Textures/daily.tga");
	end,
	GetText = function()
		local dailyAkt, dailyMax = Daily_count();
		local dailyPercent = dailyAkt / dailyMax * 100;
		local text1 = dailyAkt.."/"..dailyMax;
		local textout = getColorFormated((dailyPercent), 99, 80, 50, text1);
		return(textout);
	end,
	x = 64,
	OnLoad = function(this)		
	end,
	OnEvent = function(event)
	end,
	OnUpdate = function()
	end,
	OnClick = function()
		ToggleUIFrame(getglobal("UI_QuestBook"));
	end,
	OnEnter = function(this)
		RoMBaTooltipAnchor(this:GetName());
		RoMBaTooltip:SetText(QUEST_TRACK_TOOLTIP_DAILY_TITLE);
		
		local anzQuest = g_NumTotalQuest;
		if anzQuest > 0 then
			for i=1, anzQuest, 1 do
				local qIndex, qCatalogID, qName, qTrack, qLV, qbDaily,qbDaily_num, qType = GetQuestInfo(i);
				if qbDaily_num == 1 then
					RoMBaTooltip:AddLine(setColoredText("GOLD",qName));
					
					local anzUP	= GetQuestRequest( i, -1 );
					if anzUP > 0 then
						for y = 1, anzUP, 1 do
							local qCol = "RED";
							local qText, qFinish = GetQuestRequest( i, y );
							if qFinish ~= 0 then 
								qCol = "GREEN";
							end;
							RoMBaTooltip:AddLine(setColoredText(qCol, qText));
						end;
					end;
					RoMBaTooltip:AddLine(" ");
				end;
			end;
		end;
	end,
	OnLeave = function()
		RoMBaTooltip:Hide();
	end
};