--[=[ RoMBaconfig
	by Caandera
	released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
]=]
local RoMBaConfigFrame = nil;

local anzahlBars = 4;
StaticPopupDialogs["ROMBARESET"] = {
	text = rombaLocale["Messages"]["RESETCONFIG"],
	button1 = TEXT(rombaLocale["Messages"]["YES"]),
	button2 = TEXT(rombaLocale["Messages"]["NO"]),
	OnAccept = function()
		RoMBaGlobalReset();
		RoMBaFrame_Update();
	end,
	timeout = 0,
	whileDead = 1,
	exclusive = 1,
	showAlert = 1,
	hideOnEscape = 1
};


function RoMBaConfig_OnLoad(this)
	RoMBaConfigFrame = this;
	PanelTemplates_SetNumTabs(this, 5);
	PanelTemplates_SetTab(RoMBaConfigFrame, 1);
	
	RoMBaConfigTab1:SetText(rombaLocale["Config"]["TAB1"]);
	RoMBaConfigTab2:SetText(rombaLocale["Config"]["TAB2"]);
	RoMBaConfigTab3:SetText(rombaLocale["Config"]["TAB3"]);
	RoMBaConfigTab4:SetText(rombaLocale["Config"]["TAB4"]);
	RoMBaConfigTab5:SetText(rombaLocale["Config"]["TAB5"]);
	
	RoMBaCmdTitle1:SetText(rombaLocale["Description"]["DESC21"]);
	RoMBaCmdTitleLine1:SetText(rombaLocale["Description"]["DESC31"]);
	RoMBaCmdTitle2:SetText(rombaLocale["Description"]["DESC21"]);
	RoMBaCmdTitleLine2:SetText(rombaLocale["Description"]["DESC31"]);

	RoMBAConfigTitle:SetText(rombaLocale["Config"]["TITLE"]);
	RoMBaSmileyVisibleText:SetText(rombaLocale["Config"]["EMOTE"]);
	RoMBaBookVisibleText:SetText(rombaLocale["Config"]["BOOK"]);
	RoMBaMenuVisibleText:SetText(rombaLocale["Config"]["MENU"]);
	RoMBaDisplayVisibleText:SetText(rombaLocale["Config"]["VISUAL"]);
	RoMBaNotesVisibleText:SetText(rombaLocale["Config"]["SOUND"]);
	RoMBaExitVisibleText:SetText(rombaLocale["Config"]["EXIT"]);
	RoMBaTimeVisibleText:SetText(rombaLocale["Config"]["TIME"]);
	RoMBaAlphaSliderText:SetText(rombaLocale["Config"]["SLIDERALPHA"]);
	RoMBaConfig_OK:SetText(rombaLocale["Config"]["BUTTONCLOSE"]);
	
	RoMBaPosButtonText:SetText(rombaLocale["Config"]["POSITION"]);
	RoMBaClockmodeButtonText:SetText(rombaLocale["Config"]["FADING"]);
	RoMBaMovePFButtonText:SetText(rombaLocale["Config"]["MOVEPF"]);
	RoMBaMoveTFButtonText:SetText(rombaLocale["Config"]["MOVETF"]);
	RoMBaMovePBFButtonText:SetText(rombaLocale["Config"]["MOVEPBF"]);
	RoMBaMoveUFButtonText:SetText(rombaLocale["Config"]["MOVEUF"]);
	RoMBaMoveMMButtonText:SetText(rombaLocale["Config"]["MOVEMM"]);
--	RoMBaMoveRFButtonText:SetText(rombaLocale["Config"]["MOVERF"]);
	RoMBaRemoveXpbarButtonText:SetText(rombaLocale["Config"]["REMXP"]);
	RoMBaMoveEFButtonText:SetText(rombaLocale["Config"]["MOVEEF"]);
	RoMBaMoveMMFButtonText:SetText(rombaLocale["Config"]["MOVEMMF"]);
	RoMBaAlphaSlider2Text:SetText(rombaLocale["Config"]["SLIDERALPHA2"]);
	
	RoMBaDmgOverrideText:SetText(rombaLocale["Config"]["OVERRIDEDMG"]);
	RoMBaConfig_Reset:SetText(rombaLocale["Messages"]["RESETCONFIG"]);
	
	RoMBaAlphaSlider:SetValueStepMode("FLOAT");
	RoMBaAlphaSlider:SetMinMaxValues(0.0, 1);
	RoMBaAlphaSlider:SetValue(0.5);
	
	RoMBaAlphaSlider2:SetValueStepMode("FLOAT");
	RoMBaAlphaSlider2:SetMinMaxValues(0.0, 1);
	RoMBaAlphaSlider2:SetValue(0.5);
	
	RoMBaAlarmSet:SetChecked(nil);
	RoMBaAlarmHour:SetNumber(0);
	RoMBaAlarmMinute:SetNumber(0);
	RoMBaAlarmUS:SetText("AM");
	RoMBaAlarmReason:SetText("");

	RoMBaAfkMsg:SetText(rombaLocale["Messages"]["DEFAULTAFK"]);
	RoMBaAfkPre1:SetText("afk");
	RoMBaAfkPre2:SetText("re");
	
	RoMBaAlarmSetText:SetText(rombaLocale["Config"]["ALARMON"]);
	RoMBaAlarmHourText:SetText(rombaLocale["Config"]["ALARMTIME"]);
	RoMBaAlarmReasonText:SetText(rombaLocale["Config"]["ALARMREASON"]);
	
	RoMBaAfkMsgText:SetText(rombaLocale["Tooltip"]["AFKMESSAGE"]);
	RoMBaAfkPre1Text:SetText(rombaLocale["Tooltip"]["AFKTEXT"]);
	RoMBaAfkPre2Text:SetText(rombaLocale["Tooltip"]["RETEXT"]);
	RoMBaAFKUmgebungText:SetText(rombaLocale["Config"]["AFKVicinity"]);
	RoMBaAFKPartyText:SetText(rombaLocale["Config"]["AFKParty"]);
	RoMBaAFKGildeText:SetText(rombaLocale["Config"]["AFKGuild"]);
end;

function RoMBaConfig_Execute(varStr)
	if varStr == "IconSmiley" then
		RoMBaVariables[varStr] = (RoMBaSmileyVisible:IsChecked()and true) or false;
		if (RoMBaSmileyVisible:IsChecked()) then
			RoMBaEmote:Show();
		else
			RoMBaEmote:Hide();
		end;
	elseif varStr == "IconBook" then
		RoMBaVariables[varStr] = (RoMBaBookVisible:IsChecked()and true) or false;
		if (RoMBaBookVisible:IsChecked()) then
			RoMBaBook:Show();
		else
			RoMBaBook:Hide();
		end;
	elseif varStr == "IconMenu" then
		RoMBaVariables[varStr] = (RoMBaMenuVisible:IsChecked()and true) or false;
		if (RoMBaMenuVisible:IsChecked()) then
			RoMBaCmdMenu:Show();
		else
			RoMBaCmdMenu:Hide();
		end;	
	elseif varStr == "IconDisplay" then
		RoMBaVariables[varStr] = (RoMBaDisplayVisible:IsChecked()and true) or false;
		if (RoMBaDisplayVisible:IsChecked()) then
			RoMBaDisplay:Show();
		else
			RoMBaDisplay:Hide();
		end;
	elseif varStr == "IconNotes" then
		RoMBaVariables[varStr] = (RoMBaNotesVisible:IsChecked()and true) or false;
		if (RoMBaNotesVisible:IsChecked()) then
			RoMBaVolume:Show();
		else
			RoMBaVolume:Hide();
		end;
	elseif varStr == "IconExit" then
		RoMBaVariables[varStr] = (RoMBaExitVisible:IsChecked()and true) or false;
		if (RoMBaExitVisible:IsChecked()) then
			RoMBaExit:Show();
		else
			RoMBaExit:Hide();
		end;
	elseif varStr == "IconTime" then
		RoMBaVariables[varStr] = (RoMBaTimeVisible:IsChecked()and true) or false;
		if (RoMBaTimeVisible:IsChecked()) then
			RoMBaClock:Show();
		else
			RoMBaClock:Hide();
		end;
	elseif varStr == "PosButton" then
		RoMBaVariables["BarPosition"] = (RoMBaPosButton:IsChecked()and true) or false;
	elseif varStr == "ClockmodeButton" then
		RoMBaVariables["BarFadingOn"] = (RoMBaClockmodeButton:IsChecked()and true) or false;
		RoMBaRecalcAMPM();
	elseif varStr == "MovePFButton" then
		RoMBaVariables["MovePlayerFrame"] = (RoMBaMovePFButton:IsChecked()and true) or false;
	elseif varStr == "MoveTFButton" then
		RoMBaVariables["MoveTargetFrame"] = (RoMBaMoveTFButton:IsChecked()and true) or false;
	elseif varStr == "MovePBFButton" then
		RoMBaVariables["MovePlayerBuffFrame"] = (RoMBaMovePBFButton:IsChecked()and true) or false;
	elseif varStr == "MoveUFButton" then
		RoMBaVariables["MoveUnitFrame"] = (RoMBaMoveUFButton:IsChecked()and true) or false;
--	elseif varStr == "MoveRFButton" then
--		RoMBaVariables["MoveRaidFrame"] = (RoMBaMoveRFButton:IsChecked()and true) or false;
	elseif varStr == "RemoveXpbarButton" then
		RoMBaVariables["RemoveXpbar"]  = (RoMBaRemoveXpbarButton:IsChecked() and true) or false;
	elseif varStr == "MoveEFButton" then
		RoMBaVariables["MoveExperienceFrame"] = (RoMBaMoveEFButton:IsChecked()and true) or false;
	elseif varStr == "MoveMMFButton" then
		RoMBaVariables["MoveMainMenuFrame"] = (RoMBaMoveMMFButton:IsChecked()and true) or false;
	elseif varStr == "MoveMMButton" then
		RoMBaVariables["MoveMiniMapFrame"] = (RoMBaMoveMMButton:IsChecked()and true) or false;
	elseif varStr == "AFKVicinity" then
		RoMBaVariables["AfkVicOff"] = (not RoMBaAFKUmgebung:IsChecked()and true) or false;
	elseif varStr == "AFKParty" then
		RoMBaVariables["AfkParOff"] = (not RoMBaAFKParty:IsChecked()and true) or false;
	elseif varStr == "AFKGilde" then
		RoMBaVariables["AfkGilOff"] = (not RoMBaAFKGilde:IsChecked()and true) or false;
	end;
	
	doMoveDontMove();
	RoMBaIconsMove();
end;

function doMoveDontMove()
	if RomBaPosition == "up" then
		RoMBa_resetUpper();
		RoMBa_moveUpper();
	else
		RoMBa_resetLower();
		RoMBa_moveLower();
	end;
end;

function RoMBaConfig_Setup()
	RoMBaSmileyVisible:SetChecked((RoMBaVariables["IconSmiley"] and 1) or nil);
	RoMBaBookVisible:SetChecked((RoMBaVariables["IconBook"] and 1) or nil);
	RoMBaMenuVisible:SetChecked((RoMBaVariables["IconMenu"] and 1) or nil);
	RoMBaDisplayVisible:SetChecked((RoMBaVariables["IconDisplay"] and 1) or nil);
	RoMBaNotesVisible:SetChecked((RoMBaVariables["IconNotes"] and 1) or nil);
	RoMBaExitVisible:SetChecked((RoMBaVariables["IconExit"] and 1) or nil);
	RoMBaTimeVisible:SetChecked((RoMBaVariables["IconTime"] and 1) or nil);
	RoMBaDmgOverride:SetChecked((RoMBaVariables["DmgOverride"] and 1) or nil);
	RoMBaAlphaSlider:SetValue(RoMBaVariables["BarTransparency"]);
	
	RoMBaFrame:SetAlpha(RoMBaVariables["BarTransparency"]);
	
	RoMBaPosButton:SetChecked((RoMBaVariables["BarPosition"] and 1) or nil);
	RoMBaClockmodeButton:SetChecked((RoMBaVariables["BarFadingOn"] and 1) or nil);
	RoMBaMovePFButton:SetChecked((RoMBaVariables["MovePlayerFrame"] and 1) or nil);
	RoMBaMoveTFButton:SetChecked((RoMBaVariables["MoveTargetFrame"] and 1) or nil);
	RoMBaMovePBFButton:SetChecked((RoMBaVariables["MovePlayerBuffFrame"] and 1) or nil);
	RoMBaMoveUFButton:SetChecked((RoMBaVariables["MoveUnitFrame"] and 1) or nil);
	RoMBaMoveEFButton:SetChecked((RoMBaVariables["MoveExperienceFrame"] and 1) or nil);
	RoMBaMoveMMFButton:SetChecked((RoMBaVariables["MoveMainMenuFrame"] and 1) or nil);
	RoMBaMoveMMButton:SetChecked((RoMBaVariables["MoveMiniMapFrame"] and 1) or nil);
	RoMBaRemoveXpbarButton:SetChecked((RoMBaVariables["RemoveXpbar"] and 1) or nil);
	RoMBaStyleDropDownText:SetText(rombaLocale["Config"][RoMBaVariables["BarStyle"]]);
	RoMBaAlphaSlider2:SetValue(RoMBaVariables["BackgroundTransparency"]);
	
	for i = 1, 5 do
		local frameWert = getglobal("RoMBaFrameArt"..i);
		frameWert:SetAlpha(RoMBaVariables["BackgroundTransparency"]);
		frameWert:SetTexture("Interface/AddOns/RoMBa/Textures/"..RoMBaVariables["BarStyle"]..".tga");
	end;
	
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown1Text, "Item1");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown2Text, "Item2");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown3Text, "Item3");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown4Text, "Item4");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown5Text, "Item5");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown6Text, "Item6");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown7Text, "Item7");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown8Text, "Item8");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown9Text, "Item9");
	RoMBa_SetAddonDropDown(RoMBaAddonDropDown10Text, "Item10");

	RoMBa_SetEditBox(RoMBaBox_CmdName1, "CmdName1");
	RoMBa_SetEditBox(RoMBaBox_CmdName2, "CmdName2");
	RoMBa_SetEditBox(RoMBaBox_CmdName3, "CmdName3");
	RoMBa_SetEditBox(RoMBaBox_CmdName4, "CmdName4");
	RoMBa_SetEditBox(RoMBaBox_CmdName5, "CmdName5");
	RoMBa_SetEditBox(RoMBaBox_CmdName6, "CmdName6");
	RoMBa_SetEditBox(RoMBaBox_CmdName7, "CmdName7");
	RoMBa_SetEditBox(RoMBaBox_CmdName8, "CmdName8");
	RoMBa_SetEditBox(RoMBaBox_CmdName9, "CmdName9");
	RoMBa_SetEditBox(RoMBaBox_CmdName10, "CmdName10");
	RoMBa_SetEditBox(RoMBaBox_CmdName11, "CmdName11");
	RoMBa_SetEditBox(RoMBaBox_CmdName12, "CmdName12");
	RoMBa_SetEditBox(RoMBaBox_CmdName13, "CmdName13");
	RoMBa_SetEditBox(RoMBaBox_CmdName14, "CmdName14");
	RoMBa_SetEditBox(RoMBaBox_CmdName15, "CmdName15");
	RoMBa_SetEditBox(RoMBaBox_CmdName16, "CmdName16");
	RoMBa_SetEditBox(RoMBaBox_CmdName17, "CmdName17");
	RoMBa_SetEditBox(RoMBaBox_CmdName18, "CmdName18");
	RoMBa_SetEditBox(RoMBaBox_CmdName19, "CmdName19");
	RoMBa_SetEditBox(RoMBaBox_CmdName20, "CmdName20");
	
	RoMBa_SetEditBox(RoMBaBox_CmdLine1, "CmdLine1");
	RoMBa_SetEditBox(RoMBaBox_CmdLine2, "CmdLine2");
	RoMBa_SetEditBox(RoMBaBox_CmdLine3, "CmdLine3");
	RoMBa_SetEditBox(RoMBaBox_CmdLine4, "CmdLine4");
	RoMBa_SetEditBox(RoMBaBox_CmdLine5, "CmdLine5");
	RoMBa_SetEditBox(RoMBaBox_CmdLine6, "CmdLine6");
	RoMBa_SetEditBox(RoMBaBox_CmdLine7, "CmdLine7");
	RoMBa_SetEditBox(RoMBaBox_CmdLine8, "CmdLine8");
	RoMBa_SetEditBox(RoMBaBox_CmdLine9, "CmdLine9");
	RoMBa_SetEditBox(RoMBaBox_CmdLine10, "CmdLine10");
	RoMBa_SetEditBox(RoMBaBox_CmdLine11, "CmdLine11");
	RoMBa_SetEditBox(RoMBaBox_CmdLine12, "CmdLine12");
	RoMBa_SetEditBox(RoMBaBox_CmdLine13, "CmdLine13");
	RoMBa_SetEditBox(RoMBaBox_CmdLine14, "CmdLine14");
	RoMBa_SetEditBox(RoMBaBox_CmdLine15, "CmdLine15");
	RoMBa_SetEditBox(RoMBaBox_CmdLine16, "CmdLine16");
	RoMBa_SetEditBox(RoMBaBox_CmdLine17, "CmdLine17");
	RoMBa_SetEditBox(RoMBaBox_CmdLine18, "CmdLine18");
	RoMBa_SetEditBox(RoMBaBox_CmdLine19, "CmdLine19");
	RoMBa_SetEditBox(RoMBaBox_CmdLine20, "CmdLine20");

	if (RoMBaVariables["AfkMsg"] ~= nil) then
		RoMBaAfkMsg:SetText(RoMBaVariables["AfkMsg"]);
	else
		RoMBaAfkMsg:SetText(rombaLocale["Messages"]["DEFAULTAFK"]);
	end;

	if (RoMBaVariables["Afktxtafk"] ~= nil) then
		RoMBaAfkPre1:SetText(RoMBaVariables["Afktxtafk"]);
	else
		RoMBaAfkPre1:SetText("afk");
	end;
	
	if (RoMBaVariables["Afktxtre"] ~= nil) then
		RoMBaAfkPre2:SetText(RoMBaVariables["Afktxtre"]);
	else
		RoMBaAfkPre2:SetText("re");
	end;
	
	RoMBaAFKUmgebung:SetChecked((not RoMBaVariables["AfkVicOff"] and 1) or nil);
	RoMBaAFKParty:SetChecked((not RoMBaVariables["AfkParOff"] and 1) or nil);
	RoMBaAFKGilde:SetChecked((not RoMBaVariables["AfkGilOff"] and 1) or nil);
	
	RoMBaRecalcAMPM();
	
	if not (RoMBaVariables["IconSmiley"]) then
		RoMBaEmote:Hide();
	else
		RoMBaEmote:Show();
	end;
	if not (RoMBaVariables["IconBook"]) then
		RoMBaBook:Hide();
	else
		RoMBaBook:Show();
	end;
	if not (RoMBaVariables["IconMenu"]) then
		RoMBaCmdMenu:Hide();
	else
		RoMBaCmdMenu:Show();
	end;
	if not (RoMBaVariables["IconDisplay"]) then
		RoMBaDisplay:Hide();
	else
		RoMBaDisplay:Show();
	end;
	if not (RoMBaVariables["IconNotes"]) then
		RoMBaVolume:Hide();
	else
		RoMBaVolume:Show();
	end;
	if not (RoMBaVariables["IconExit"]) then
		RoMBaExit:Hide();
	else
		RoMBaExit:Show();
	end;
	if not (RoMBaVariables["IconTime"]) then
		RoMBaClock:Hide();
	else
		RoMBaClock:Show();
	end;
	RoMBaIconsMove();
end;

function RoMBaAlphaSlider_OnValueChanged()
	if (RoMBaConfig:IsVisible()) then
		local alphaVal = RoMBaAlphaSlider:GetValue();
		RoMBaFrame:SetAlpha(alphaVal);
		RoMBaVariables["BarTransparency"] = alphaVal;
	end;
end;

function RoMBaAlphaSlider2_OnValueChanged()
	if (RoMBaConfig:IsVisible()) then
		local alphaVal = RoMBaAlphaSlider2:GetValue();
		for i = 1, 5 do
			local frameWert = getglobal("RoMBaFrameArt"..i);
			frameWert:SetAlpha(alphaVal);
		end;
		RoMBaVariables["BackgroundTransparency"] = alphaVal;
	end;
end;

function RoMBaConfigButton_Click()
	RoMBaConfig:Hide();
end;

function RoMBaIconsMove()
	local xPos = 60;
	local yPos = 16;
	local referTo = "MinimapFrameBorder";
	local referPoint = "TOPLEFT";	
	
	if RomBaPosition == "up" then
		local point, relativePoint, relativeTo, xOff, yOff = MinimapFrameBorder:GetAnchor();
		if not MinimapFrameBorder:IsVisible() or yOff >= 24 then
			referTo = "UIParent";
			referPoint = "TOPRIGHT";
			xPos = -5;
		end;
	else
		referTo = "UIParent";
		referPoint = "BOTTOMRIGHT";
		yPos = -9;
		xPos = -5;		
	end;
	
	RoMBaLocation:ClearAllAnchors();
	RoMBaLocation:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
    xPos = xPos - 40;
	
	if (RoMBaVariables["IconTime"] and RoMBaClock ~= nil) then
		RoMBaClock:ClearAllAnchors();
		RoMBaClock:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
		xPos = xPos - 50;
	end;
	if (RoMBaVariables["IconExit"] and RoMBaExit ~= nil) then
		RoMBaExit:ClearAllAnchors();
		RoMBaExit:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
        xPos = xPos - 20;
	end;
	if (RoMBaVariables["IconNotes"] and RoMBaVolume ~= nil) then
		RoMBaVolume:ClearAllAnchors();
		RoMBaVolume:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
        xPos = xPos - 20;
	end;
	if (RoMBaVariables["IconDisplay"] and RoMBaDisplay ~= nil) then
		RoMBaDisplay:ClearAllAnchors();
		RoMBaDisplay:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
        xPos = xPos - 20;
	end;
	if (RoMBaVariables["IconMenu"] and RoMBaCmdMenu ~= nil) then
		RoMBaCmdMenu:ClearAllAnchors();
		RoMBaCmdMenu:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
        xPos = xPos - 20;
	end;
	if (RoMBaVariables["IconBook"] and RoMBaBook ~= nil) then
		RoMBaBook:ClearAllAnchors();
		RoMBaBook:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
        xPos = xPos - 20;
	end;
	if (RoMBaVariables["IconSmiley"] and RoMBaEmote ~= nil) then
		RoMBaEmote:ClearAllAnchors();
		RoMBaEmote:SetAnchor("RIGHT", referPoint, referTo, xPos, yPos);
	end;
end;

function RoMBaConfigTab_OnClick(id)
	if (RoMBaConfigFrame ~= nil) then
		PanelTemplates_SetTab(RoMBaConfigFrame, id);
	end;
	if ( id == 1 ) then
		ConfigFrame1:Show();
		ConfigFrame2:Hide();
		ConfigFrame3:Hide();
		ConfigFrame4:Hide();
		ConfigFrame5:Hide();
	elseif ( id == 2 ) then
		ConfigFrame2:Show();
		ConfigFrame1:Hide();
		ConfigFrame3:Hide();
		ConfigFrame4:Hide();
		ConfigFrame5:Hide();
	elseif ( id == 3) then
		ConfigFrame3:Show();
		ConfigFrame1:Hide();
		ConfigFrame2:Hide();
		ConfigFrame4:Hide();
		ConfigFrame5:Hide();
	elseif ( id == 4) then
		ConfigFrame4:Show();
		ConfigFrame1:Hide();
		ConfigFrame2:Hide();
		ConfigFrame3:Hide();
		ConfigFrame5:Hide();
    else
		ConfigFrame5:Show();
		ConfigFrame1:Hide();
		ConfigFrame2:Hide();
		ConfigFrame3:Hide();
        ConfigFrame4:Hide();
	end;
end;

function RoMBa_SetEditBox(this, boxVar)
	if (RoMBaVariables[boxVar] ~= nil) then
		this:SetText(RoMBaVariables[boxVar]);
	else
		this:SetText("");
	end;
end;

function RoMBa_SetAddonDropDown(this, boxVar)
	if (RoMBaVariables[boxVar] ~= nil) then
		this:SetText(RoMBaVariables[boxVar]);
	else
		this:SetText("");
	end;
end;

function RoMBaEditItemChange(this)
	--RoMBaVariables["Item"..this:GetID()] = this:GetText();
end;
function RoMBaEditNameChange(this)
	RoMBaVariables["CmdName"..this:GetID()] = this:GetText();
end;
function RoMBaEditCmdChange(this)
	RoMBaVariables["CmdLine"..this:GetID()] = this:GetText();
end;

function RoMBaResetButton_Click()
	StaticPopup_Show("ROMBARESET");
end;

function RoMBaDmgOverride_Change()
	RoMBaVariables["DmgOverride"] = (RoMBaDmgOverride:IsChecked()and true) or false;
end;


function RoMBaAddonDropDown_OnLoad(this)
	UIDropDownMenu_SetWidth(this, 118);
	UIDropDownMenu_Initialize(this, RoMBaAddonDropDown_Show);
	local RoMBaAddonDropDown = getglobal(this:GetName());
	UIDropDownMenu_SetSelectedID(RoMBaAddonDropDown, 1);
end;

function RoMBaAddonDropDown_Show(this)
	for name, value in pairs(RoMBaNode) do
		local info = {};
		info.text = name;
		info.func = RoMBaAddonDropDown_Click;
		info.value = {["Frame"] = this:GetName(), ["Name"] = name};
		UIDropDownMenu_AddButton(info);
	end;
	
	local info = {};
	info.text = "-";
	info.func = RoMBaAddonDropDown_Click;
	info.value = {["Frame"] = this:GetName(), ["Name"] = ""};
	UIDropDownMenu_AddButton(info);
end;

function RoMBaAddonDropDown_Click(button)
	local RoMBaAddonDropDown = getglobal(button.value["Frame"]);
	UIDropDownMenu_SetSelectedID(RoMBaAddonDropDown, button:GetID());
	if button.value["Name"] ~= "-" then
		RoMBaVariables["Item"..RoMBaAddonDropDown:GetID()] = getglobal(button.value["Frame"].."Text"):GetText();
	else
		RoMBaVariables["Item"..RoMBaAddonDropDown:GetID()] = nil;
	end;
	RoMBaFrame_Update();
end;

function getDropdownId(wert)
	local xx = 0;
	local val2 = 0;
	if type(RoMBaNode) == "table" then
		for name, value in pairs(RoMBaNode) do
			xx = xx + 1;
			if name == wert then
				val2=xx;
			end;
		end;
		if val2 == 0 then
			val2 = xx + 1;
		end;
	end;
	return(val2);
end;

function RoMBaStyleDropDown_OnLoad(this)
	UIDropDownMenu_SetWidth(this, 118);
	UIDropDownMenu_Initialize(this, RoMBaStyleDropDown_Show);
	UIDropDownMenu_SetSelectedID(RoMBaStyleDropDown, 1);
end;

function RoMBaStyleDropDown_Show(this)
	for i = 1, anzahlBars do
		local info = {};
		info.text = rombaLocale["Config"]["bar"..i];
		info.func = RoMBaStyleDropDown_Click;
		UIDropDownMenu_AddButton(info);
	end;
end;

function RoMBaStyleDropDown_Click(button)
	UIDropDownMenu_SetSelectedID(RoMBaStyleDropDown, button:GetID());
	for i = 1, anzahlBars do
		local frameWert = getglobal("RoMBaFrameArt"..i);
		frameWert:SetTexture("Interface/AddOns/RoMBa/Textures/bar"..button:GetID()..".tga");
	end;
	RoMBaVariables["BarStyle"] = "bar"..button:GetID();
end;

function RoMBaAlarmTime()
	local RBminute = RoMBaAlarmMinute:GetNumber();
	local RBhour = RoMBaAlarmHour:GetNumber();
	if RoMBaClockmodeButton:IsChecked() then	
		if RBhour == 12 then 
			RBhour = 0;
		end;
		if RoMBaAlarmUS:GetText() == "PM" then
			RBhour = RBhour + 12;
		end;
	end;
	return string.format("%02d:%02d", RBhour, RBminute);
end;

function RoMBaAlarmFrame_Update()
	local alarmHH = RoMBaAlarmHour:GetNumber();
	local alarmMM = RoMBaAlarmMinute:GetNumber();
	if RoMBaClockmodeButton:IsChecked() and RoMBaAlarmUS:IsVisible() then
		if alarmHH < 1 or alarmHH > 12 then
			 RoMBaAlarmHour:SetNumber(12);
		end;
	else
		if alarmHH < 0 or alarmHH > 23 then
			 RoMBaAlarmHour:SetNumber(0);
		end;
	end;
	if alarmMM < 0 or alarmMM > 59 then
		RoMBaAlarmMinute:SetNumber(0);
	end;
end;

function RoMBaAfkMsgChange()
	RoMBaVariables["AfkMsg"] = RoMBaAfkMsg:GetText();
end;

function RoMBaAfkPre1Change()
	RoMBaVariables["Afktxtafk"] = RoMBaAfkPre1:GetText();
end;

function RoMBaAfkPre2Change()
	RoMBaVariables["Afktxtre"] = RoMBaAfkPre2:GetText();
end;

function AlarmTimeAMPMClick()
	if RoMBaAlarmUS:GetText() == "AM" then
		RoMBaAlarmUS:SetText("PM");
	else
		RoMBaAlarmUS:SetText("AM");
	end;
end;

function RoMBaRecalcAMPM()
	if RoMBaClockmodeButton:IsChecked() and not RoMBaAlarmUS:IsVisible() then
		RoMBaAlarmUS:SetText("AM");
		local RBhour = RoMBaAlarmHour:GetNumber();
		RoMBaAlarmUS:Show();
		if RBhour > 12 then
			RBhour = RBhour - 12;
			RoMBaAlarmUS:SetText("PM");
		end;
		if RBhour == 0 then 
			RBhour = 12;
		end;
		RoMBaAlarmHour:SetNumber(RBhour);
	end;
	if not RoMBaClockmodeButton:IsChecked() and RoMBaAlarmUS:IsVisible() then
		local RBhour = RoMBaAlarmHour:GetNumber();
		RoMBaAlarmUS:Hide();
		if RBhour == 12 then 
			RBhour = 0;
		end;
		if RoMBaAlarmUS:GetText() == "PM" then
			RBhour = RBhour + 12;
		end;
		RoMBaAlarmHour:SetNumber(RBhour);
	end;
end;