--[=[ RoMBalib
	by Caandera
	released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
]=]
RomBaPosition = "up";
local RoMBaName = "RoMBa";
--local RoMBaVersion = "1.34";
local RoMBaAuthor = "Caandera";

function RoMBaFrame_OnLoad(this)
	SlashCmdList["ROMBA"] = romba_SlashHandler;
	SLASH_ROMBA1 = "/romba";
	this:RegisterEvent("VARIABLES_LOADED");
	SaveVariables("RoMBaVariables");
	AddRoMBaToAddonmanager();
end;

function RoMBaFrame_Event(e)
	if (e == "VARIABLES_LOADED") then
		RombaGlobalInitialize();
		RoMBaConfig_Setup();
	end;
end;

function RoMBaFrame_Update()
	if (type(RoMBaVariables) == "table") then
		for i = 1,10 do
			local button = getglobal("RoMBaSymbol"..i);
			if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..i]] ~= nil) then
				local info = RoMBaNode[RoMBaVariables["Item"..i]];
				getglobal(button:GetName().."Icon"):SetTexture(info.GetIcon());
				getglobal(button:GetName().."Text"):SetText(info.GetText());
				button:SetWidth(info.x) ;
				button:Show();
			else
				button:Hide();
				button:SetWidth(0) ;
			end;
		end;
		
		if RoMBaVariables["RemoveXpbar"] then
			if  (ExperienceFrame:IsVisible() or MainMenuFrame:IsVisible()) then
				 ExperienceFrame:Hide();
				 MainMenuFrame:Hide();
			end;
		else
			if  (not ExperienceFrame:IsVisible() or not MainMenuFrame:IsVisible()) then
				 ExperienceFrame:Show();
				 MainMenuFrame:Show();
			end;
		end;
		
		local tempPos = "up";
		if RoMBaVariables["BarPosition"] then
			tempPos = "down";
		else
			tempPos = "up";
		end;
		if RomBaPosition ~= tempPos then
			RomBaPosition = tempPos;
			RoMBaSetBar();
			RoMBaIconsMove();
		end;
		if getSessionMinutes() < 1 and not RoMBaTooltip:IsVisible() then
			RoMBaIconsMove();
		end;
		
		RoMBaMoveFrames();
	end;
end;

function romba_SlashHandler(a,msg)
	if (string.lower(msg) == "on") then
		RoMBaHidden = false;
		RoMBaFrame:Show();
	elseif (string.lower(msg) == "off") then
		RoMBaHidden = true;
		RoMBaFrame:Hide();
	elseif string.lower(msg) == "help" or string.lower(msg) == "h" then
		DEFAULT_CHAT_FRAME:AddMessage("RoMBa "..rombaLocale["Messages"]["HELP"]..":",1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/romba on - "..rombaLocale["Messages"]["TOGGLEON"],1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage("/romba off - "..rombaLocale["Messages"]["TOGGLEOFF"],1,1,1);
		DEFAULT_CHAT_FRAME:AddMessage(rombaLocale["Messages"]["CONFIG"],1,1,1);
	elseif (msg == "" or string.lower(msg) == "config") then
		doFrameCmd(RoMBaConfig);
	end;	
end;

function RoMBaGetCharAbi(abil)
	local baseValue, otherValue = GetPlayerAbility(abil);
	local wert = baseValue+otherValue;
	local outstr = string.format(math.ceil(wert).." ("..math.ceil(baseValue)..")");
	return outstr;
end;

function RoMBaLevel(wer)
	local mlvl, slvl = UnitLevel("player");
	if wer == 2 then
		outstr = slvl;
	else
		outstr = mlvl;
	end;
	return outstr;
end;

function doFrameCmd(myFrame)
	if (myFrame:IsVisible()) then
		myFrame:Hide();
	else
		myFrame:Show();
	end;
end;

function RoMBaTooltipAnchor(objectName, right)
	RoMBaTooltip:ClearAllAnchors();
	if RomBaPosition == "up" then
		if (right) then
			RoMBaTooltip:SetAnchor("TOPRIGHT", "BOTTOMRIGHT", objectName, 0, 0);
		else
			RoMBaTooltip:SetAnchor("TOPLEFT", "BOTTOMLEFT", objectName, 0, 0);
		end;
	else
		if (right) then
			RoMBaTooltip:SetAnchor("BOTTOMRIGHT", "TOPRIGHT", objectName, 0, 0);
		else
			RoMBaTooltip:SetAnchor("BOTTOMLEFT", "TOPLEFT", objectName, 0, 0);
		end;
	end;
end;

function RoMBaDropDownAnchor(objectName)
	if RomBaPosition == "up" then
		objectName.point = nil;
		objectName.relativePoint = nil;
	else
		RoMBaDropDownCommandMenu.point = "BOTTOMLEFT";
		RoMBaDropDownCommandMenu.relativePoint = "TOPLEFT";
	end;
end;

function RoMBaSetBar()
	RoMBaFrame:ClearAllAnchors();
	if RomBaPosition == "up" then
		RoMBaFrame:SetAnchor("TOPLEFT");
	else
		RoMBaFrame:SetAnchor("TOPLEFT", "BOTTOMLEFT", "UIParent", 0, -25);
	end;
end;

function RoMBaLeftButton_OnLoad(this)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnLoad ) then
			info.OnLoad(this);
		end;
	end;
end;
function RoMBaLeftButton_OnEvent(this, event)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnEvent ) then
			info.OnEvent(event);
		end;
	end;
end;
function RoMBaLeftButton_OnUpdate(this)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnUpdate ) then
			info.OnUpdate();
		end;
		RoMBaLeftButton_OnLoad(this);
	end;
end;
function RoMBaLeftButton_OnClick(this, key)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnClick ) then
			info.OnClick(key);
		end;
	end;
end;
function RoMBaLeftButton_OnEnter(this)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnEnter ) then
			info.OnEnter(this);
		end;
	end;
end;
function RoMBaLeftButton_OnLeave(this)
	if (type(RoMBaVariables) == "table" and type(RoMBaNode) == "table" and RoMBaNode[RoMBaVariables["Item"..this:GetID()]] ~= nil) then
		local info = RoMBaNode[RoMBaVariables["Item"..this:GetID()]];
		if ( info.OnLeave ) then
			info.OnLeave();
		end;
	end;
end;



function RoMBaFrame_ShowIt()
	if type(RoMBaVariables) == "table" and RoMBaVariables["BarFadingOn"] then
		RoMBaFrame:Show();
	end;
end;

function RoMBaFrame_HideIt()
	if type(RoMBaVariables) == "table" and RoMBaVariables["BarFadingOn"] then
		--local posX, posY = GetCursorPos();
		--if posY > 30 then
			RoMBaFrame:Hide();
		--end;
	end;
end;

function RoMBaMoveFrames()
	if RomBaPosition == "up" then
		RoMBa_moveUpper();
	else
		RoMBa_moveLower();
	end;
end;

function AddRoMBaToAddonmanager()
	if AddonManager then
		local addon = {
			name = RoMBaName,
			version = RoMBaVersion,
			author = RoMBaAuthor,
			description = rombaLocale["Description"]["AddonManInfo"],
			icon = "Interface\\AddOns\\RoMBa\\Textures\\romba.png",
			category = "Information",
			configFrame = RoMBaConfig, 
			slashCommands = "/romba",
			miniButton = RoMBaMiniButton,
		}
		if AddonManager.RegisterAddonTable then
			AddonManager.RegisterAddonTable(addon)
		end
	end
end;