--[=[ RoMBamenu
	by Caandera
	released under the Creative Commons License By-Nc-Sa: http://creativecommons.org/licenses/by-nc-sa/3.0/
]=]
local timeSwitch = 1;
local afk = 0;
local rombaFunctionDD = {
	"GAME_MENU_DISPLAYOPTION","SYS_Settings_Frame",
	"GAME_MENU_MUSICOPTION","SYS_Settings_Frame",
	"SSF_MIC_SELECT","SYS_Settings_Frame",
	"GAME_MENU_UIOPTION","GameConfigFrame",
	"GAME_MENU_KEYBINDING","KeyDefineFrame",
	"GAME_MENU_MACRO","MacroFrame",
	"GAME_MENU_TUTORIAL","TeachingFrame",
	"GAME_MENU_GM_NOTIFICATION","GmNotificationFrame",
	"GAME_MENU_WEDGE_REPORT","NOFRAME",
	"GAME_MENU_EXIT","NOFRAME",
	--[=["GAME_MENU_QUIT","NOFRAME",]=]
	"SYSTEM_INSTANCE_RECORD","InstanceRecordFrame",
	"BILLBOARD","SortScoreBoard",
	"SUITSKILL_FRAME","SkillSuitFrame",
	"DRAWRUNE_STR_RUNE","DrawRuneFrame"
};
local rombaFunctionLendDD = {
	"TIMEFLAG_HANDY_BANK","BankLet",
	"TIMEFLAG_HANDY_AUCTION","AuctionLet",
	"TIMEFLAG_HANDY_MAIL","MailLet"
};

function emoteLoad(this)
	this:RegisterForClicks("LeftButton", "RightButton");
	RoMBaEmoteText:SetText(" ");
	RoMBaEmoteIcon:SetTexture("Interface/AddOns/RoMBa/Textures/emote.tga");
end;
function emoteClick(key)
	if key == "LBUTTON" then
		doFrameCmd(SocialFrame);
	elseif key == "RBUTTON" then
		ShowEmotesDropDown();
	end;
end;
function emoteTooltip()
	RoMBaTooltipAnchor("RoMBaEmote");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["SMILEY"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", getglobal("BINDING_NAME_TOGGLESOCIALFRAME")..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", getglobal("BINDING_NAME_TOGGLECHARACTER4")..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["RIGHTCLICK"]);
end;

function bookLoad(this)
	this:RegisterForClicks("LeftButton", "RightButton");
	RoMBaBookText:SetText(" ");
	RoMBaBookIcon:SetTexture("Interface/AddOns/RoMBa/Textures/book.tga");
end;
function bookClick(key)
	if key == "LBUTTON" then
		doFrameCmd(TeleportBook);
	elseif key == "RBUTTON" then
		doFrameCmd(CardBookFrame);
	end;
end;
function bookTooltip()
	RoMBaTooltipAnchor("RoMBaBook");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["BOOKS"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", getglobal("TB_TITLE")..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", getglobal("CARDBOOK_TAB_1")..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["RIGHTCLICK"]);
end;

function cmdMenuLoad()
	RoMBaCmdMenuText:SetText(" ");
	RoMBaCmdMenuIcon:SetTexture("Interface/AddOns/RoMBa/Textures/menu.tga");
end;
function cmdMenuClick()
	ShowCommandDropDown();
end;
function cmdMenuTooltip()
	RoMBaTooltipAnchor("RoMBaCmdMenu");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["CMDMENU"]);
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
end;

function displayLoad(this)
	this:RegisterForClicks("LeftButton", "RightButton");
	RoMBaDisplayText:SetText(" ");
	RoMBaDisplayIcon:SetTexture("Interface/AddOns/RoMBa/Textures/settings.tga");
end;
function displayClick(key)
	if key == "LBUTTON" then
		ShowFunctionDropDown();
	elseif key == "RBUTTON" then
		ShowFunctionDropDownLend();
	end;
end;
function displayTooltip()
	RoMBaTooltipAnchor("RoMBaDisplay");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["SYSFUNC"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", getglobal("SYSTEM_TOOLTIP")));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", rombaLocale["Tooltip"]["MOBILEFUNC"]));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["RIGHTCLICK"]);
end;

function volumeLoad(this)
	this:RegisterEvent("CHAT_MSG_WHISPER");
	this:RegisterEvent("CHAT_MSG_PARTY");
	this:RegisterEvent("CHAT_MSG_GUILD");
	RoMBaVolumeText:SetText(" ");
	RoMBaVolumeIcon:SetTexture("Interface/AddOns/RoMBa/Textures/afkno.tga");
end;
function volumeClick()
	if afk == 0 then
		RoMBaAfk(1);
	else
		RoMBaAfk(0);
	end;
end;
function volumeEvent(event)
	if (afk == 1 and event == "CHAT_MSG_WHISPER") then
		SendChatMessage(RoMBaAfkMsg:GetText(), "WHISPER", 0, arg4);
	elseif (afk == 1 and event == "CHAT_MSG_PARTY" and arg1 ~= nil and UnitName("player") ~= nil and string.find(string.lower(arg1), string.lower(UnitName("player"))) ~= nil) then
		SendChatMessage(RoMBaAfkMsg:GetText(), "PARTY");
	elseif (afk == 1 and event == "CHAT_MSG_GUILD" and arg1 ~= nil and UnitName("player") ~= nil and  string.find(string.lower(arg1), string.lower(UnitName("player"))) ~= nil) then
		SendChatMessage(RoMBaAfkMsg:GetText(), "GUILD");
	end;
end;
function volumeTooltip()
	RoMBaTooltipAnchor("RoMBaVolume");
	RoMBaTooltip:SetText("AFK");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	if afk == 0 then
		RoMBaTooltip:AddLine(setColoredText("GOLD", "AFK "..rombaLocale["Messages"]["ON"]));
	else
		RoMBaTooltip:AddLine(setColoredText("GOLD", "AFK "..rombaLocale["Messages"]["OFF"]));
	end;
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", rombaLocale["Tooltip"]["AFKMESSAGE"]));
	RoMBaTooltip:AddLine(RoMBaAfkMsg:GetText());
end;

function exitLoad()
	RoMBaExitText:SetText(" ");
	RoMBaExitIcon:SetTexture("Interface/AddOns/RoMBa/Textures/shutdown.tga");
end;
function exitClick()
	if (IsShiftKeyDown()) then
		QuitGame();
	else
		Logout();
	end;
end;
function exitTooltip()
	RoMBaTooltipAnchor("RoMBaExit");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["EXIT"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", rombaLocale["Tooltip"]["LOGOUT"]..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", rombaLocale["Tooltip"]["SHUTDOWN"]..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["SHIFTLEFTCLICK"]);
end;

function clockClick()
	timeSwitch = timeSwitch * -1;
end;
function clockUpdate()
	local textColor = "WHITE";
	if RoMBaAlarmSet:IsChecked() then
		textColor = "ORANGE";
	end;
	if timeSwitch == 1 then
		--local myClock = os.date("%H:%M");
		local myClock = MorphClock:date("%H:%M");
		if RoMBaClockmodeButton:IsChecked() then
			--myClock = RoMBaCalcTime(tonumber(os.date("%H")), tonumber(os.date("%M")));
			myClock = RoMBaCalcTime(tonumber(MorphClock:date("%H")), tonumber(MorphClock:date("%M")));
		end;
		RoMBaClockText:SetText(setColoredText(textColor, myClock));
	else
		RoMBaClockText:SetText(setColoredText(textColor, getSessionTime()));
	end;
    
	--if RoMBaAlarmSet:IsChecked() and os.date("%H:%M") == RoMBaAlarmTime() then
	if RoMBaAlarmSet:IsChecked() and MorphClock:date("%H:%M") == RoMBaAlarmTime() then
        -- Alarm aktivert und Zeit erreicht
        -- Grund anzeigen
		if RoMBaAlarmReason:GetText() ~= "" then
			ScrollBannerFrame_AddMessage(RoMBaAlarmReason:GetText());
		end;
		-- Alarmton aktivieren
		PlaySoundByPath("Interface/Addons/RoMBa/Audio/alarm.wav")
		-- Alarm abschalten
		RoMBaAlarmSet:SetChecked(nil);
	end;
end;

function clockTooltip()
	RoMBaTooltipAnchor("RoMBaClock");
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["TIME"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(rombaLocale["Tooltip"]["DATE"]);
	--RoMBaTooltip:AddLine(os.date("%d-%m-%y"));
	RoMBaTooltip:AddLine(MorphClock:date("%d-%m-%y"));
	RoMBaTooltip:AddLine(" ");
	if RoMBaAlarmSet:IsChecked() then
		RoMBaTooltip:AddLine(rombaLocale["Config"]["TAB5"]);
		if RoMBaClockmodeButton:IsChecked() then
			RoMBaTooltip:AddLine(RoMBaShowTwelveAlarmTime());
		else
			RoMBaTooltip:AddLine(RoMBaAlarmTime());
		end;
		RoMBaTooltip:AddLine(" ");
	end;
	if timeSwitch == 1 then
		RoMBaTooltip:AddLine(rombaLocale["Tooltip"]["GAMETIME"]);
		RoMBaTooltip:AddLine(getSessionTime());
	else
		--local myClock = os.date("%H:%M");
		local myClock = MorphClock:date("%H:%M");
		if RoMBaClockmodeButton:IsChecked() then
			--myClock = RoMBaCalcTime(tonumber(os.date("%H")), tonumber(os.date("%M")));
			myClock = RoMBaCalcTime(tonumber(MorphClock:date("%H")), tonumber(MorphClock:date("%M")));
		end;
		RoMBaTooltip:AddLine(rombaLocale["Tooltip"]["TIME"]);
		RoMBaTooltip:AddLine(myClock);
	end;
end;
function locationLoad(this)
	this:RegisterForClicks("LeftButton", "RightButton");
	RoMBaLocationIcon:SetTexture("Interface/AddOns/RoMBa/Textures/map.tga");
end;
function locationUpdate()
	RoMBaLocationText:SetText(GetCurrentParallelID());
end;
function locationClick(key)
	if key == "LBUTTON" and GetZoneID() ~= 400 then
		doFrameCmd(WorldMapFrame);
	elseif key == "RBUTTON" then
		RoMBaDropDownAnchor(PlayerParallelDropDown);		
		ToggleDropDownMenu(PlayerParallelDropDown, 1, nil, "RoMBaLocation");
	end;
end;
function locationTooltip()
	RoMBaTooltipAnchor("RoMBaLocation", true);
	RoMBaTooltip:SetText(rombaLocale["Tooltip"]["ACTPOS"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", TEXT( "UI_WORLDMAP_TITLE" ) ..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["LEFTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(setColoredText("GOLD", TEXT("PARALLEL_SELECT")..": "));
	RoMBaTooltip:AddLine(rombaLocale["Messages"]["RIGHTCLICK"]);
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddLine(" ");
	RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["POSITION"]..":"), GetZoneName());
	RoMBaTooltip:AddDoubleLine(setColoredText("GOLD", rombaLocale["Tooltip"]["ZONEID"]..":"), GetZoneID());
end;

function RoMBaDropDownMenuInit(this)
	UIDropDownMenu_Initialize(this, RoMBaEmoteOptionMenu);
end;
function RoMBaEmoteOptionMenu(this)
	local info = {};
	for itemNr = 0 , GetEmoteInfoCount() - 1 do
		info = {};
		emoteNr, emoteName = GetEmoteInfo(itemNr);
		info.text = emoteName;
		info.value = emoteNr;
		info.func = RoMBaDoEmote;
		info.owner	= DropDownframe;
		
		UIDropDownMenu_AddButton(info);
	end;
	info = {};
	info.text = getglobal("CANCEL");
	info.value = 0;
	info.func = function() end;
	info.owner	= DropDownframe;
	UIDropDownMenu_AddButton(info);
end;
function ShowEmotesDropDown()
	RoMBaDropDownAnchor(RoMBaDropDownMenu);
	ToggleDropDownMenu(RoMBaDropDownMenu, 1, nil, "RoMBaEmote");
end;
function RoMBaDoEmote(button)
	DoEmote(button.value);
end;

function RoMBaDropDownMenuCommandInit(this)
	UIDropDownMenu_Initialize(this, RoMBaCommandMenu);
end;
function RoMBaCommandMenu(this)
	if (type(RoMBaVariables) == "table") then
		local info = {};
		for cmdNr = 1 , 20 do
			if RoMBaVariables["CmdName"..cmdNr] ~= nil and RoMBaVariables["CmdName"..cmdNr] ~= "" then
				info = {};
				info.text =RoMBaVariables["CmdName"..cmdNr];
				info.value = cmdNr;
				info.func = RoMBaDoCommand;
				info.owner	= DropDownframe;
				
				UIDropDownMenu_AddButton(info);
			end;
		end;
	end;
	info = {};
	info.text = getglobal("CANCEL");
	info.value = 0;
	info.func = function() end;
	info.owner	= DropDownframe;
	UIDropDownMenu_AddButton(info);
end;
function ShowCommandDropDown()
	
	RoMBaDropDownAnchor(RoMBaDropDownCommandMenu);
	ToggleDropDownMenu(RoMBaDropDownCommandMenu, 1, nil, "RoMBaCmdMenu");
end;
function RoMBaDoCommand(button)
	ExecuteMacroLine(RoMBaVariables["CmdLine"..button.value]);
end;

function RoMBaAfk(state)
	if state == 1 then
		afk = 1;
		RoMBaVolumeIcon:SetTexture("Interface/AddOns/RoMBa/Textures/afkyes.tga");
		if RoMBaAFKUmgebung:IsChecked() then
			SendChatMessage(UnitName("player")..rombaLocale["Messages"]["ISAFK"], "SAY");
		end;
		if RoMBaAFKParty:IsChecked() then
			SendChatMessage(RoMBaAfkPre1:GetText(), "PARTY");
		end;
		if RoMBaAFKGilde:IsChecked() then
			SendChatMessage(RoMBaAfkPre1:GetText(), "GUILD");
		end;
	else
		afk = 0;
		RoMBaVolumeIcon:SetTexture("Interface/AddOns/RoMBa/Textures/afkno.tga");
		if RoMBaAFKUmgebung:IsChecked() then
			SendChatMessage(UnitName("player")..rombaLocale["Messages"]["ISBACK"], "SAY");
		end;
		if RoMBaAFKParty:IsChecked() then
			SendChatMessage(RoMBaAfkPre2:GetText(), "PARTY");
		end;
		if RoMBaAFKGilde:IsChecked() then
			SendChatMessage(RoMBaAfkPre2:GetText(), "GUILD");
		end;
	end;
end;

function RoMBaDropDownMenuFunctionInit(this)
	UIDropDownMenu_Initialize(this, RoMBaFunctionMenu);
end;
function RoMBaFunctionMenu(this)
	local info = {};
	for funcNr = 1 , 14 do
		info = {};
		info.text = getglobal(rombaFunctionDD[funcNr * 2 - 1]);
		info.value = funcNr;
		info.func = RoMBaDoFunction;
		info.owner	= DropDownframe;
			
		UIDropDownMenu_AddButton(info);
	end;
	info = {};
	info.text = getglobal("CANCEL");
	info.value = 0;
	info.func = function() end;
	info.owner	= DropDownframe;
	UIDropDownMenu_AddButton(info);
end;
function ShowFunctionDropDown()
	
	RoMBaDropDownAnchor(RoMBaDropDownFunctionMenu);
	ToggleDropDownMenu(RoMBaDropDownFunctionMenu, 1, nil, "RoMBaDisplay");
end;
function RoMBaDoFunction(button)
	if button.value < 4 then
		GameMenuFrame.SSFTab = button.value;
	end;
	if rombaFunctionDD[button.value * 2] ~= "NOFRAME" and button.value < 11 then
		ShowUIPanel(getglobal(rombaFunctionDD[button.value * 2]));
	else
		if button.value == 9 then
			SendWedgePointReport();
		elseif button.value == 10 then
			Logout();
		elseif button.value == 15 then
			StaticPopup_Show("QUIT");
		elseif button.value >10 and button.value < 15 then
			ToggleUIFrame(getglobal(rombaFunctionDD[button.value * 2]));
		end;
	end;
end;

function RoMBaCalcTime(twentyfourhour, twentyfourminute)
	local twelveend = "PM";
	local twelvehour = 0;
	if twentyfourhour < 12 then
		twelveend = "AM";
		twelvehour = twentyfourhour;
		if twentyfourhour == 0 then
			twelvehour = 12;
		end;
	else
		twelvehour = twentyfourhour - 12;
		if twelvehour == 0 then
			twelvehour = 12;
		end;
	end;
	return string.format("%02d:%02d "..twelveend, twelvehour, twentyfourminute);
end;

function RoMBaShowTwelveAlarmTime()
	local RBminute = RoMBaAlarmMinute:GetNumber();
	local RBhour = RoMBaAlarmHour:GetNumber();
	local RBending = RoMBaAlarmUS:GetText();
	return string.format("%02d:%02d "..RBending, RBhour, RBminute);
end;

function RoMBaDropDownMenuFunctionLendInit(this)
	UIDropDownMenu_Initialize(this, RoMBaFunctionLendMenu);
end;
function RoMBaFunctionLendMenu(this)
	local info = {};
	for funcNr = 1 , 3 do
		info = {};
		info.text = getglobal(rombaFunctionLendDD[funcNr * 2 - 1]);
		info.value = funcNr;
		info.func = RoMBaDoFunctionLend;
		info.owner	= DropDownframe;
		
		if( TimeLet_GetLetTime( rombaFunctionLendDD[funcNr * 2 ]) > 0 ) then
			UIDropDownMenu_AddButton(info);
		end;	
	end;
	info = {};
	info.text = getglobal("CANCEL");
	info.value = 0;
	info.func = function() end;
	info.owner	= DropDownframe;
	UIDropDownMenu_AddButton(info);
end;
function ShowFunctionDropDownLend()
	
	RoMBaDropDownAnchor(RoMBaDropDownFunctionMenu2);
	ToggleDropDownMenu(RoMBaDropDownFunctionMenu2, 1, nil, "RoMBaDisplay");
end;
function RoMBaDoFunctionLend(button)
	if( TimeLet_GetLetTime( rombaFunctionLendDD[button.value * 2 ]) > 0 ) then
		if button.value == 1 then
			OpenBank();
		elseif button.value == 2 then
			OpenAuction();
		elseif button.value == 3 then
			OpenMail();
		end;
	end;
end;
